
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TAnchorSide struct {
    IObject
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// CN: 动态转换一个已存在的对象实例。或者使用Obj.As().<目标对象>。
// EN: Dynamically convert an existing object instance. Or use Obj.As().<Target object>.
func AsAnchorSide(obj interface{}) *TAnchorSide {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TAnchorSide{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// CN: 新建一个对象来自已经存在的对象实例指针。
// EN: Create a new object from an existing object instance pointer.
// Deprecated: use AsAnchorSide.
func AnchorSideFromInst(inst uintptr) *TAnchorSide {
    return AsAnchorSide(inst)
}

// CN: 新建一个对象来自已经存在的对象实例。
// EN: Create a new object from an existing object instance.
// Deprecated: use AsAnchorSide.
func AnchorSideFromObj(obj IObject) *TAnchorSide {
    return AsAnchorSide(obj)
}

// CN: 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// EN: Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsAnchorSide.
func AnchorSideFromUnsafePointer(ptr unsafe.Pointer) *TAnchorSide {
    return AsAnchorSide(ptr)
}

// -------------------------- Deprecated end --------------------------
// CN: 返回对象实例指针。
// EN: Return object instance pointer.
func (a *TAnchorSide) Instance() uintptr {
    return a.instance
}

// CN: 获取一个不安全的地址。
// EN: Get an unsafe address.
func (a *TAnchorSide) UnsafeAddr() unsafe.Pointer {
    return a.ptr
}

// CN: 检测地址是否为空。
// EN: Check if the address is empty.
func (a *TAnchorSide) IsValid() bool {
    return a.instance != 0
}

// CN: 检测当前对象是否继承自目标对象。
// EN: Checks whether the current object is inherited from the target object.
func (a *TAnchorSide) Is() TIs {
    return TIs(a.instance)
}

// CN: 动态转换当前对象为目标对象。
// EN: Dynamically convert the current object to the target object.
//func (a *TAnchorSide) As() TAs {
//    return TAs(a.instance)
//}

// CN: 获取类信息指针。
// EN: Get class information pointer.
func TAnchorSideClass() TClass {
    return AnchorSide_StaticClassType()
}

// CN: 复制一个对象，如果对象实现了此方法的话。
// EN: Copy an object, if the object implements this method.
func (a *TAnchorSide) Assign(Source IObject) {
    AnchorSide_Assign(a.instance, CheckPtr(Source))
}

// CN: 获取类名路径。
// EN: Get the class name path.
func (a *TAnchorSide) GetNamePath() string {
    return AnchorSide_GetNamePath(a.instance)
}

// CN: 获取类的类型信息。
// EN: Get class type information.
func (a *TAnchorSide) ClassType() TClass {
    return AnchorSide_ClassType(a.instance)
}

// CN: 获取当前对象类名称。
// EN: Get the current object class name.
func (a *TAnchorSide) ClassName() string {
    return AnchorSide_ClassName(a.instance)
}

// CN: 获取当前对象实例大小。
// EN: Get the current object instance size.
func (a *TAnchorSide) InstanceSize() int32 {
    return AnchorSide_InstanceSize(a.instance)
}

// CN: 判断当前类是否继承自指定类。
// EN: Determine whether the current class inherits from the specified class.
func (a *TAnchorSide) InheritsFrom(AClass TClass) bool {
    return AnchorSide_InheritsFrom(a.instance, AClass)
}

// CN: 与一个对象进行比较。
// EN: Compare with an object.
func (a *TAnchorSide) Equals(Obj IObject) bool {
    return AnchorSide_Equals(a.instance, CheckPtr(Obj))
}

// CN: 获取类的哈希值。
// EN: Get the hash value of the class.
func (a *TAnchorSide) GetHashCode() int32 {
    return AnchorSide_GetHashCode(a.instance)
}

// CN: 文本类信息。
// EN: Text information.
func (a *TAnchorSide) ToString() string {
    return AnchorSide_ToString(a.instance)
}

// CN: 获取组件所有者。
// EN: Get component owner.
func (a *TAnchorSide) Owner() *TControl {
    return AsControl(AnchorSide_GetOwner(a.instance))
}

func (a *TAnchorSide) Control() *TControl {
    return AsControl(AnchorSide_GetControl(a.instance))
}

func (a *TAnchorSide) SetControl(value IControl) {
    AnchorSide_SetControl(a.instance, CheckPtr(value))
}

func (a *TAnchorSide) Side() TAnchorSideReference {
    return AnchorSide_GetSide(a.instance)
}

func (a *TAnchorSide) SetSide(value TAnchorSideReference) {
    AnchorSide_SetSide(a.instance, value)
}

