
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TButton struct {
    IWinControl
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// CN: 创建一个新的对象。
// EN: Create a new object.
func NewButton(owner IComponent) *TButton {
    b := new(TButton)
    b.instance = Button_Create(CheckPtr(owner))
    b.ptr = unsafe.Pointer(b.instance)
    // 不敢启用，因为不知道会发生什么...
    // runtime.SetFinalizer(b, (*TButton).Free)
    return b
}

// CN: 动态转换一个已存在的对象实例。或者使用Obj.As().<目标对象>。
// EN: Dynamically convert an existing object instance. Or use Obj.As().<Target object>.
func AsButton(obj interface{}) *TButton {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TButton{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// CN: 新建一个对象来自已经存在的对象实例指针。
// EN: Create a new object from an existing object instance pointer.
// Deprecated: use AsButton.
func ButtonFromInst(inst uintptr) *TButton {
    return AsButton(inst)
}

// CN: 新建一个对象来自已经存在的对象实例。
// EN: Create a new object from an existing object instance.
// Deprecated: use AsButton.
func ButtonFromObj(obj IObject) *TButton {
    return AsButton(obj)
}

// CN: 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// EN: Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsButton.
func ButtonFromUnsafePointer(ptr unsafe.Pointer) *TButton {
    return AsButton(ptr)
}

// -------------------------- Deprecated end --------------------------
// CN: 释放对象。
// EN: Free object.
func (b *TButton) Free() {
    if b.instance != 0 {
        Button_Free(b.instance)
        b.instance, b.ptr = 0, nullptr
    }
}

// CN: 返回对象实例指针。
// EN: Return object instance pointer.
func (b *TButton) Instance() uintptr {
    return b.instance
}

// CN: 获取一个不安全的地址。
// EN: Get an unsafe address.
func (b *TButton) UnsafeAddr() unsafe.Pointer {
    return b.ptr
}

// CN: 检测地址是否为空。
// EN: Check if the address is empty.
func (b *TButton) IsValid() bool {
    return b.instance != 0
}

// CN: 检测当前对象是否继承自目标对象。
// EN: Checks whether the current object is inherited from the target object.
func (b *TButton) Is() TIs {
    return TIs(b.instance)
}

// CN: 动态转换当前对象为目标对象。
// EN: Dynamically convert the current object to the target object.
//func (b *TButton) As() TAs {
//    return TAs(b.instance)
//}

// CN: 获取类信息指针。
// EN: Get class information pointer.
func TButtonClass() TClass {
    return Button_StaticClassType()
}

// CN: 单击。
// EN: .
func (b *TButton) Click() {
    Button_Click(b.instance)
}

// CN: 是否可以获得焦点。
// EN: .
func (b *TButton) CanFocus() bool {
    return Button_CanFocus(b.instance)
}

// CN: 返回是否包含指定控件。
// EN: it's contain a specified control.
func (b *TButton) ContainsControl(Control IControl) bool {
    return Button_ContainsControl(b.instance, CheckPtr(Control))
}

// CN: 返回指定坐标及相关属性位置控件。
// EN: Returns the specified coordinate and the relevant attribute position control..
func (b *TButton) ControlAtPos(Pos TPoint, AllowDisabled bool, AllowWinControls bool, AllLevels bool) *TControl {
    return AsControl(Button_ControlAtPos(b.instance, Pos , AllowDisabled , AllowWinControls , AllLevels))
}

// CN: 禁用控件的对齐。
// EN: Disable control alignment.
func (b *TButton) DisableAlign() {
    Button_DisableAlign(b.instance)
}

// CN: 启用控件对齐。
// EN: Enabled control alignment.
func (b *TButton) EnableAlign() {
    Button_EnableAlign(b.instance)
}

// CN: 查找子控件。
// EN: Find sub controls.
func (b *TButton) FindChildControl(ControlName string) *TControl {
    return AsControl(Button_FindChildControl(b.instance, ControlName))
}

func (b *TButton) FlipChildren(AllLevels bool) {
    Button_FlipChildren(b.instance, AllLevels)
}

// CN: 返回是否获取焦点。
// EN: Return to get focus.
func (b *TButton) Focused() bool {
    return Button_Focused(b.instance)
}

// CN: 句柄是否已经分配。
// EN: Is the handle already allocated.
func (b *TButton) HandleAllocated() bool {
    return Button_HandleAllocated(b.instance)
}

// CN: 插入一个控件。
// EN: Insert a control.
func (b *TButton) InsertControl(AControl IControl) {
    Button_InsertControl(b.instance, CheckPtr(AControl))
}

// CN: 要求重绘。
// EN: Redraw.
func (b *TButton) Invalidate() {
    Button_Invalidate(b.instance)
}

// CN: 移除一个控件。
// EN: Remove a control.
func (b *TButton) RemoveControl(AControl IControl) {
    Button_RemoveControl(b.instance, CheckPtr(AControl))
}

// CN: 重新对齐。
// EN: Realign.
func (b *TButton) Realign() {
    Button_Realign(b.instance)
}

// CN: 重绘。
// EN: Repaint.
func (b *TButton) Repaint() {
    Button_Repaint(b.instance)
}

// CN: 按比例缩放。
// EN: Scale by.
func (b *TButton) ScaleBy(M int32, D int32) {
    Button_ScaleBy(b.instance, M , D)
}

// CN: 滚动至指定位置。
// EN: Scroll by.
func (b *TButton) ScrollBy(DeltaX int32, DeltaY int32) {
    Button_ScrollBy(b.instance, DeltaX , DeltaY)
}

// CN: 设置组件边界。
// EN: Set component boundaries.
func (b *TButton) SetBounds(ALeft int32, ATop int32, AWidth int32, AHeight int32) {
    Button_SetBounds(b.instance, ALeft , ATop , AWidth , AHeight)
}

// CN: 设置控件焦点。
// EN: Set control focus.
func (b *TButton) SetFocus() {
    Button_SetFocus(b.instance)
}

// CN: 控件更新。
// EN: Update.
func (b *TButton) Update() {
    Button_Update(b.instance)
}

// CN: 将控件置于最前。
// EN: Bring the control to the front.
func (b *TButton) BringToFront() {
    Button_BringToFront(b.instance)
}

// CN: 将客户端坐标转为绝对的屏幕坐标。
// EN: Convert client coordinates to absolute screen coordinates.
func (b *TButton) ClientToScreen(Point TPoint) TPoint {
    return Button_ClientToScreen(b.instance, Point)
}

// CN: 将客户端坐标转为父容器坐标。
// EN: Convert client coordinates to parent container coordinates.
func (b *TButton) ClientToParent(Point TPoint, AParent IWinControl) TPoint {
    return Button_ClientToParent(b.instance, Point , CheckPtr(AParent))
}

// CN: 是否在拖拽中。
// EN: Is it in the middle of dragging.
func (b *TButton) Dragging() bool {
    return Button_Dragging(b.instance)
}

// CN: 是否有父容器。
// EN: Is there a parent container.
func (b *TButton) HasParent() bool {
    return Button_HasParent(b.instance)
}

// CN: 隐藏控件。
// EN: Hidden control.
func (b *TButton) Hide() {
    Button_Hide(b.instance)
}

// CN: 发送一个消息。
// EN: Send a message.
func (b *TButton) Perform(Msg uint32, WParam uintptr, LParam int) int {
    return Button_Perform(b.instance, Msg , WParam , LParam)
}

// CN: 刷新控件。
// EN: Refresh control.
func (b *TButton) Refresh() {
    Button_Refresh(b.instance)
}

// CN: 将屏幕坐标转为客户端坐标。
// EN: Convert screen coordinates to client coordinates.
func (b *TButton) ScreenToClient(Point TPoint) TPoint {
    return Button_ScreenToClient(b.instance, Point)
}

// CN: 将父容器坐标转为客户端坐标。
// EN: Convert parent container coordinates to client coordinates.
func (b *TButton) ParentToClient(Point TPoint, AParent IWinControl) TPoint {
    return Button_ParentToClient(b.instance, Point , CheckPtr(AParent))
}

// CN: 控件至于最后面。
// EN: The control is placed at the end.
func (b *TButton) SendToBack() {
    Button_SendToBack(b.instance)
}

// CN: 显示控件。
// EN: Show control.
func (b *TButton) Show() {
    Button_Show(b.instance)
}

// CN: 获取控件的字符，如果有。
// EN: Get the characters of the control, if any.
func (b *TButton) GetTextBuf(Buffer *string, BufSize int32) int32 {
    return Button_GetTextBuf(b.instance, Buffer , BufSize)
}

// CN: 获取控件的字符长，如果有。
// EN: Get the character length of the control, if any.
func (b *TButton) GetTextLen() int32 {
    return Button_GetTextLen(b.instance)
}

// CN: 设置控件字符，如果有。
// EN: Set control characters, if any.
func (b *TButton) SetTextBuf(Buffer string) {
    Button_SetTextBuf(b.instance, Buffer)
}

// CN: 查找指定名称的组件。
// EN: Find the component with the specified name.
func (b *TButton) FindComponent(AName string) *TComponent {
    return AsComponent(Button_FindComponent(b.instance, AName))
}

// CN: 获取类名路径。
// EN: Get the class name path.
func (b *TButton) GetNamePath() string {
    return Button_GetNamePath(b.instance)
}

// CN: 复制一个对象，如果对象实现了此方法的话。
// EN: Copy an object, if the object implements this method.
func (b *TButton) Assign(Source IObject) {
    Button_Assign(b.instance, CheckPtr(Source))
}

// CN: 获取类的类型信息。
// EN: Get class type information.
func (b *TButton) ClassType() TClass {
    return Button_ClassType(b.instance)
}

// CN: 获取当前对象类名称。
// EN: Get the current object class name.
func (b *TButton) ClassName() string {
    return Button_ClassName(b.instance)
}

// CN: 获取当前对象实例大小。
// EN: Get the current object instance size.
func (b *TButton) InstanceSize() int32 {
    return Button_InstanceSize(b.instance)
}

// CN: 判断当前类是否继承自指定类。
// EN: Determine whether the current class inherits from the specified class.
func (b *TButton) InheritsFrom(AClass TClass) bool {
    return Button_InheritsFrom(b.instance, AClass)
}

// CN: 与一个对象进行比较。
// EN: Compare with an object.
func (b *TButton) Equals(Obj IObject) bool {
    return Button_Equals(b.instance, CheckPtr(Obj))
}

// CN: 获取类的哈希值。
// EN: Get the hash value of the class.
func (b *TButton) GetHashCode() int32 {
    return Button_GetHashCode(b.instance)
}

// CN: 文本类信息。
// EN: Text information.
func (b *TButton) ToString() string {
    return Button_ToString(b.instance)
}

func (b *TButton) AnchorToNeighbour(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    Button_AnchorToNeighbour(b.instance, ASide , ASpace , CheckPtr(ASibling))
}

func (b *TButton) AnchorParallel(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    Button_AnchorParallel(b.instance, ASide , ASpace , CheckPtr(ASibling))
}

// CN: 置于指定控件的横向中心。
// EN: .
func (b *TButton) AnchorHorizontalCenterTo(ASibling IControl) {
    Button_AnchorHorizontalCenterTo(b.instance, CheckPtr(ASibling))
}

// CN: 置于指定控件的纵向中心。
// EN: .
func (b *TButton) AnchorVerticalCenterTo(ASibling IControl) {
    Button_AnchorVerticalCenterTo(b.instance, CheckPtr(ASibling))
}

func (b *TButton) AnchorAsAlign(ATheAlign TAlign, ASpace int32) {
    Button_AnchorAsAlign(b.instance, ATheAlign , ASpace)
}

func (b *TButton) AnchorClient(ASpace int32) {
    Button_AnchorClient(b.instance, ASpace)
}

func (b *TButton) Action() *TAction {
    return AsAction(Button_GetAction(b.instance))
}

func (b *TButton) SetAction(value IComponent) {
    Button_SetAction(b.instance, CheckPtr(value))
}

// CN: 获取控件自动调整。
// EN: Get Control automatically adjusts.
func (b *TButton) Align() TAlign {
    return Button_GetAlign(b.instance)
}

// CN: 设置控件自动调整。
// EN: Set Control automatically adjusts.
func (b *TButton) SetAlign(value TAlign) {
    Button_SetAlign(b.instance, value)
}

// CN: 获取四个角位置的锚点。
// EN: .
func (b *TButton) Anchors() TAnchors {
    return Button_GetAnchors(b.instance)
}

// CN: 设置四个角位置的锚点。
// EN: .
func (b *TButton) SetAnchors(value TAnchors) {
    Button_SetAnchors(b.instance, value)
}

func (b *TButton) BiDiMode() TBiDiMode {
    return Button_GetBiDiMode(b.instance)
}

func (b *TButton) SetBiDiMode(value TBiDiMode) {
    Button_SetBiDiMode(b.instance, value)
}

func (b *TButton) Cancel() bool {
    return Button_GetCancel(b.instance)
}

func (b *TButton) SetCancel(value bool) {
    Button_SetCancel(b.instance, value)
}

// CN: 获取控件标题。
// EN: Get the control title.
func (b *TButton) Caption() string {
    return Button_GetCaption(b.instance)
}

// CN: 设置控件标题。
// EN: Set the control title.
func (b *TButton) SetCaption(value string) {
    Button_SetCaption(b.instance, value)
}

// CN: 获取约束控件大小。
// EN: .
func (b *TButton) Constraints() *TSizeConstraints {
    return AsSizeConstraints(Button_GetConstraints(b.instance))
}

// CN: 设置约束控件大小。
// EN: .
func (b *TButton) SetConstraints(value *TSizeConstraints) {
    Button_SetConstraints(b.instance, CheckPtr(value))
}

func (b *TButton) Default() bool {
    return Button_GetDefault(b.instance)
}

func (b *TButton) SetDefault(value bool) {
    Button_SetDefault(b.instance, value)
}

// CN: 获取设置控件双缓冲。
// EN: Get Set control double buffering.
func (b *TButton) DoubleBuffered() bool {
    return Button_GetDoubleBuffered(b.instance)
}

// CN: 设置设置控件双缓冲。
// EN: Set Set control double buffering.
func (b *TButton) SetDoubleBuffered(value bool) {
    Button_SetDoubleBuffered(b.instance, value)
}

// CN: 获取设置控件拖拽时的光标。
// EN: Get Set the cursor when the control is dragged.
func (b *TButton) DragCursor() TCursor {
    return Button_GetDragCursor(b.instance)
}

// CN: 设置设置控件拖拽时的光标。
// EN: Set Set the cursor when the control is dragged.
func (b *TButton) SetDragCursor(value TCursor) {
    Button_SetDragCursor(b.instance, value)
}

// CN: 获取拖拽方式。
// EN: Get Drag and drop.
func (b *TButton) DragKind() TDragKind {
    return Button_GetDragKind(b.instance)
}

// CN: 设置拖拽方式。
// EN: Set Drag and drop.
func (b *TButton) SetDragKind(value TDragKind) {
    Button_SetDragKind(b.instance, value)
}

// CN: 获取拖拽模式。
// EN: Get Drag mode.
func (b *TButton) DragMode() TDragMode {
    return Button_GetDragMode(b.instance)
}

// CN: 设置拖拽模式。
// EN: Set Drag mode.
func (b *TButton) SetDragMode(value TDragMode) {
    Button_SetDragMode(b.instance, value)
}

// CN: 获取控件启用。
// EN: Get the control enabled.
func (b *TButton) Enabled() bool {
    return Button_GetEnabled(b.instance)
}

// CN: 设置控件启用。
// EN: Set the control enabled.
func (b *TButton) SetEnabled(value bool) {
    Button_SetEnabled(b.instance, value)
}

// CN: 获取字体。
// EN: Get Font.
func (b *TButton) Font() *TFont {
    return AsFont(Button_GetFont(b.instance))
}

// CN: 设置字体。
// EN: Set Font.
func (b *TButton) SetFont(value *TFont) {
    Button_SetFont(b.instance, CheckPtr(value))
}

// CN: 获取模态对话框显示结果。
// EN: .
func (b *TButton) ModalResult() TModalResult {
    return Button_GetModalResult(b.instance)
}

// CN: 设置模态对话框显示结果。
// EN: .
func (b *TButton) SetModalResult(value TModalResult) {
    Button_SetModalResult(b.instance, value)
}

// CN: 获取父容器双缓冲。
// EN: Get Parent container double buffering.
func (b *TButton) ParentDoubleBuffered() bool {
    return Button_GetParentDoubleBuffered(b.instance)
}

// CN: 设置父容器双缓冲。
// EN: Set Parent container double buffering.
func (b *TButton) SetParentDoubleBuffered(value bool) {
    Button_SetParentDoubleBuffered(b.instance, value)
}

// CN: 获取父容器字体。
// EN: Get Parent container font.
func (b *TButton) ParentFont() bool {
    return Button_GetParentFont(b.instance)
}

// CN: 设置父容器字体。
// EN: Set Parent container font.
func (b *TButton) SetParentFont(value bool) {
    Button_SetParentFont(b.instance, value)
}

// CN: 获取以父容器的ShowHint属性为准。
// EN: .
func (b *TButton) ParentShowHint() bool {
    return Button_GetParentShowHint(b.instance)
}

// CN: 设置以父容器的ShowHint属性为准。
// EN: .
func (b *TButton) SetParentShowHint(value bool) {
    Button_SetParentShowHint(b.instance, value)
}

// CN: 获取右键菜单。
// EN: Get Right click menu.
func (b *TButton) PopupMenu() *TPopupMenu {
    return AsPopupMenu(Button_GetPopupMenu(b.instance))
}

// CN: 设置右键菜单。
// EN: Set Right click menu.
func (b *TButton) SetPopupMenu(value IComponent) {
    Button_SetPopupMenu(b.instance, CheckPtr(value))
}

// CN: 获取显示鼠标悬停提示。
// EN: Get Show mouseover tips.
func (b *TButton) ShowHint() bool {
    return Button_GetShowHint(b.instance)
}

// CN: 设置显示鼠标悬停提示。
// EN: Set Show mouseover tips.
func (b *TButton) SetShowHint(value bool) {
    Button_SetShowHint(b.instance, value)
}

// CN: 获取Tab切换顺序序号。
// EN: Get Tab switching sequence number.
func (b *TButton) TabOrder() TTabOrder {
    return Button_GetTabOrder(b.instance)
}

// CN: 设置Tab切换顺序序号。
// EN: Set Tab switching sequence number.
func (b *TButton) SetTabOrder(value TTabOrder) {
    Button_SetTabOrder(b.instance, value)
}

// CN: 获取Tab可停留。
// EN: Get Tab can stay.
func (b *TButton) TabStop() bool {
    return Button_GetTabStop(b.instance)
}

// CN: 设置Tab可停留。
// EN: Set Tab can stay.
func (b *TButton) SetTabStop(value bool) {
    Button_SetTabStop(b.instance, value)
}

// CN: 获取控件可视。
// EN: Get the control visible.
func (b *TButton) Visible() bool {
    return Button_GetVisible(b.instance)
}

// CN: 设置控件可视。
// EN: Set the control visible.
func (b *TButton) SetVisible(value bool) {
    Button_SetVisible(b.instance, value)
}

// CN: 设置控件单击事件。
// EN: Set control click event.
func (b *TButton) SetOnClick(fn TNotifyEvent) {
    Button_SetOnClick(b.instance, fn)
}

// CN: 设置上下文弹出事件，一般是右键时弹出。
// EN: Set Context popup event, usually pop up when right click.
func (b *TButton) SetOnContextPopup(fn TContextPopupEvent) {
    Button_SetOnContextPopup(b.instance, fn)
}

// CN: 设置拖拽下落事件。
// EN: Set Drag and drop event.
func (b *TButton) SetOnDragDrop(fn TDragDropEvent) {
    Button_SetOnDragDrop(b.instance, fn)
}

// CN: 设置拖拽完成事件。
// EN: Set Drag and drop completion event.
func (b *TButton) SetOnDragOver(fn TDragOverEvent) {
    Button_SetOnDragOver(b.instance, fn)
}

// CN: 设置拖拽结束。
// EN: Set End of drag.
func (b *TButton) SetOnEndDrag(fn TEndDragEvent) {
    Button_SetOnEndDrag(b.instance, fn)
}

// CN: 设置焦点进入。
// EN: Set Focus entry.
func (b *TButton) SetOnEnter(fn TNotifyEvent) {
    Button_SetOnEnter(b.instance, fn)
}

// CN: 设置焦点退出。
// EN: Set Focus exit.
func (b *TButton) SetOnExit(fn TNotifyEvent) {
    Button_SetOnExit(b.instance, fn)
}

// CN: 设置键盘按键按下事件。
// EN: Set Keyboard button press event.
func (b *TButton) SetOnKeyDown(fn TKeyEvent) {
    Button_SetOnKeyDown(b.instance, fn)
}

func (b *TButton) SetOnKeyPress(fn TKeyPressEvent) {
    Button_SetOnKeyPress(b.instance, fn)
}

// CN: 设置键盘按键抬起事件。
// EN: Set Keyboard button lift event.
func (b *TButton) SetOnKeyUp(fn TKeyEvent) {
    Button_SetOnKeyUp(b.instance, fn)
}

// CN: 设置鼠标按下事件。
// EN: Set Mouse down event.
func (b *TButton) SetOnMouseDown(fn TMouseEvent) {
    Button_SetOnMouseDown(b.instance, fn)
}

// CN: 设置鼠标进入事件。
// EN: Set Mouse entry event.
func (b *TButton) SetOnMouseEnter(fn TNotifyEvent) {
    Button_SetOnMouseEnter(b.instance, fn)
}

// CN: 设置鼠标离开事件。
// EN: Set Mouse leave event.
func (b *TButton) SetOnMouseLeave(fn TNotifyEvent) {
    Button_SetOnMouseLeave(b.instance, fn)
}

// CN: 设置鼠标移动事件。
// EN: .
func (b *TButton) SetOnMouseMove(fn TMouseMoveEvent) {
    Button_SetOnMouseMove(b.instance, fn)
}

// CN: 设置鼠标抬起事件。
// EN: Set Mouse lift event.
func (b *TButton) SetOnMouseUp(fn TMouseEvent) {
    Button_SetOnMouseUp(b.instance, fn)
}

// CN: 获取依靠客户端总数。
// EN: .
func (b *TButton) DockClientCount() int32 {
    return Button_GetDockClientCount(b.instance)
}

// CN: 获取停靠站点。
// EN: Get Docking site.
func (b *TButton) DockSite() bool {
    return Button_GetDockSite(b.instance)
}

// CN: 设置停靠站点。
// EN: Set Docking site.
func (b *TButton) SetDockSite(value bool) {
    Button_SetDockSite(b.instance, value)
}

// CN: 获取鼠标是否在客户端，仅VCL有效。
// EN: Get Whether the mouse is on the client, only VCL is valid.
func (b *TButton) MouseInClient() bool {
    return Button_GetMouseInClient(b.instance)
}

// CN: 获取当前停靠的可视总数。
// EN: Get The total number of visible calls currently docked.
func (b *TButton) VisibleDockClientCount() int32 {
    return Button_GetVisibleDockClientCount(b.instance)
}

// CN: 获取画刷对象。
// EN: Get Brush.
func (b *TButton) Brush() *TBrush {
    return AsBrush(Button_GetBrush(b.instance))
}

// CN: 获取子控件数。
// EN: Get Number of child controls.
func (b *TButton) ControlCount() int32 {
    return Button_GetControlCount(b.instance)
}

// CN: 获取控件句柄。
// EN: Get Control handle.
func (b *TButton) Handle() HWND {
    return Button_GetHandle(b.instance)
}

// CN: 获取父容器句柄。
// EN: Get Parent container handle.
func (b *TButton) ParentWindow() HWND {
    return Button_GetParentWindow(b.instance)
}

// CN: 设置父容器句柄。
// EN: Set Parent container handle.
func (b *TButton) SetParentWindow(value HWND) {
    Button_SetParentWindow(b.instance, value)
}

func (b *TButton) Showing() bool {
    return Button_GetShowing(b.instance)
}

// CN: 获取使用停靠管理。
// EN: .
func (b *TButton) UseDockManager() bool {
    return Button_GetUseDockManager(b.instance)
}

// CN: 设置使用停靠管理。
// EN: .
func (b *TButton) SetUseDockManager(value bool) {
    Button_SetUseDockManager(b.instance, value)
}

func (b *TButton) BoundsRect() TRect {
    return Button_GetBoundsRect(b.instance)
}

func (b *TButton) SetBoundsRect(value TRect) {
    Button_SetBoundsRect(b.instance, value)
}

// CN: 获取客户区高度。
// EN: Get client height.
func (b *TButton) ClientHeight() int32 {
    return Button_GetClientHeight(b.instance)
}

// CN: 设置客户区高度。
// EN: Set client height.
func (b *TButton) SetClientHeight(value int32) {
    Button_SetClientHeight(b.instance, value)
}

func (b *TButton) ClientOrigin() TPoint {
    return Button_GetClientOrigin(b.instance)
}

// CN: 获取客户区矩形。
// EN: Get client rectangle.
func (b *TButton) ClientRect() TRect {
    return Button_GetClientRect(b.instance)
}

// CN: 获取客户区宽度。
// EN: Get client width.
func (b *TButton) ClientWidth() int32 {
    return Button_GetClientWidth(b.instance)
}

// CN: 设置客户区宽度。
// EN: Set client width.
func (b *TButton) SetClientWidth(value int32) {
    Button_SetClientWidth(b.instance, value)
}

// CN: 获取控件状态。
// EN: Get control state.
func (b *TButton) ControlState() TControlState {
    return Button_GetControlState(b.instance)
}

// CN: 设置控件状态。
// EN: Set control state.
func (b *TButton) SetControlState(value TControlState) {
    Button_SetControlState(b.instance, value)
}

// CN: 获取控件样式。
// EN: Get control style.
func (b *TButton) ControlStyle() TControlStyle {
    return Button_GetControlStyle(b.instance)
}

// CN: 设置控件样式。
// EN: Set control style.
func (b *TButton) SetControlStyle(value TControlStyle) {
    Button_SetControlStyle(b.instance, value)
}

func (b *TButton) Floating() bool {
    return Button_GetFloating(b.instance)
}

// CN: 获取控件父容器。
// EN: Get control parent container.
func (b *TButton) Parent() *TWinControl {
    return AsWinControl(Button_GetParent(b.instance))
}

// CN: 设置控件父容器。
// EN: Set control parent container.
func (b *TButton) SetParent(value IWinControl) {
    Button_SetParent(b.instance, CheckPtr(value))
}

// CN: 获取左边位置。
// EN: Get Left position.
func (b *TButton) Left() int32 {
    return Button_GetLeft(b.instance)
}

// CN: 设置左边位置。
// EN: Set Left position.
func (b *TButton) SetLeft(value int32) {
    Button_SetLeft(b.instance, value)
}

// CN: 获取顶边位置。
// EN: Get Top position.
func (b *TButton) Top() int32 {
    return Button_GetTop(b.instance)
}

// CN: 设置顶边位置。
// EN: Set Top position.
func (b *TButton) SetTop(value int32) {
    Button_SetTop(b.instance, value)
}

// CN: 获取宽度。
// EN: Get width.
func (b *TButton) Width() int32 {
    return Button_GetWidth(b.instance)
}

// CN: 设置宽度。
// EN: Set width.
func (b *TButton) SetWidth(value int32) {
    Button_SetWidth(b.instance, value)
}

// CN: 获取高度。
// EN: Get height.
func (b *TButton) Height() int32 {
    return Button_GetHeight(b.instance)
}

// CN: 设置高度。
// EN: Set height.
func (b *TButton) SetHeight(value int32) {
    Button_SetHeight(b.instance, value)
}

// CN: 获取控件光标。
// EN: Get control cursor.
func (b *TButton) Cursor() TCursor {
    return Button_GetCursor(b.instance)
}

// CN: 设置控件光标。
// EN: Set control cursor.
func (b *TButton) SetCursor(value TCursor) {
    Button_SetCursor(b.instance, value)
}

// CN: 获取组件鼠标悬停提示。
// EN: Get component mouse hints.
func (b *TButton) Hint() string {
    return Button_GetHint(b.instance)
}

// CN: 设置组件鼠标悬停提示。
// EN: Set component mouse hints.
func (b *TButton) SetHint(value string) {
    Button_SetHint(b.instance, value)
}

// CN: 获取组件总数。
// EN: Get the total number of components.
func (b *TButton) ComponentCount() int32 {
    return Button_GetComponentCount(b.instance)
}

// CN: 获取组件索引。
// EN: Get component index.
func (b *TButton) ComponentIndex() int32 {
    return Button_GetComponentIndex(b.instance)
}

// CN: 设置组件索引。
// EN: Set component index.
func (b *TButton) SetComponentIndex(value int32) {
    Button_SetComponentIndex(b.instance, value)
}

// CN: 获取组件所有者。
// EN: Get component owner.
func (b *TButton) Owner() *TComponent {
    return AsComponent(Button_GetOwner(b.instance))
}

// CN: 获取组件名称。
// EN: Get the component name.
func (b *TButton) Name() string {
    return Button_GetName(b.instance)
}

// CN: 设置组件名称。
// EN: Set the component name.
func (b *TButton) SetName(value string) {
    Button_SetName(b.instance, value)
}

// CN: 获取对象标记。
// EN: Get the control tag.
func (b *TButton) Tag() int {
    return Button_GetTag(b.instance)
}

// CN: 设置对象标记。
// EN: Set the control tag.
func (b *TButton) SetTag(value int) {
    Button_SetTag(b.instance, value)
}

// CN: 获取左边锚点。
// EN: .
func (b *TButton) AnchorSideLeft() *TAnchorSide {
    return AsAnchorSide(Button_GetAnchorSideLeft(b.instance))
}

// CN: 设置左边锚点。
// EN: .
func (b *TButton) SetAnchorSideLeft(value *TAnchorSide) {
    Button_SetAnchorSideLeft(b.instance, CheckPtr(value))
}

// CN: 获取顶边锚点。
// EN: .
func (b *TButton) AnchorSideTop() *TAnchorSide {
    return AsAnchorSide(Button_GetAnchorSideTop(b.instance))
}

// CN: 设置顶边锚点。
// EN: .
func (b *TButton) SetAnchorSideTop(value *TAnchorSide) {
    Button_SetAnchorSideTop(b.instance, CheckPtr(value))
}

// CN: 获取右边锚点。
// EN: .
func (b *TButton) AnchorSideRight() *TAnchorSide {
    return AsAnchorSide(Button_GetAnchorSideRight(b.instance))
}

// CN: 设置右边锚点。
// EN: .
func (b *TButton) SetAnchorSideRight(value *TAnchorSide) {
    Button_SetAnchorSideRight(b.instance, CheckPtr(value))
}

// CN: 获取底边锚点。
// EN: .
func (b *TButton) AnchorSideBottom() *TAnchorSide {
    return AsAnchorSide(Button_GetAnchorSideBottom(b.instance))
}

// CN: 设置底边锚点。
// EN: .
func (b *TButton) SetAnchorSideBottom(value *TAnchorSide) {
    Button_SetAnchorSideBottom(b.instance, CheckPtr(value))
}

func (b *TButton) ChildSizing() *TControlChildSizing {
    return AsControlChildSizing(Button_GetChildSizing(b.instance))
}

func (b *TButton) SetChildSizing(value *TControlChildSizing) {
    Button_SetChildSizing(b.instance, CheckPtr(value))
}

// CN: 获取边框间距。
// EN: .
func (b *TButton) BorderSpacing() *TControlBorderSpacing {
    return AsControlBorderSpacing(Button_GetBorderSpacing(b.instance))
}

// CN: 设置边框间距。
// EN: .
func (b *TButton) SetBorderSpacing(value *TControlBorderSpacing) {
    Button_SetBorderSpacing(b.instance, CheckPtr(value))
}

// CN: 获取指定索引停靠客户端。
// EN: .
func (b *TButton) DockClients(Index int32) *TControl {
    return AsControl(Button_GetDockClients(b.instance, Index))
}

// CN: 获取指定索引子控件。
// EN: .
func (b *TButton) Controls(Index int32) *TControl {
    return AsControl(Button_GetControls(b.instance, Index))
}

// CN: 获取指定索引组件。
// EN: Get the specified index component.
func (b *TButton) Components(AIndex int32) *TComponent {
    return AsComponent(Button_GetComponents(b.instance, AIndex))
}

// CN: 获取锚侧面。
// EN: .
func (b *TButton) AnchorSide(AKind TAnchorKind) *TAnchorSide {
    return AsAnchorSide(Button_GetAnchorSide(b.instance, AKind))
}

