
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TJPEGImage struct {
    IObject
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// CN: 创建一个新的对象。
// EN: Create a new object.
func NewJPEGImage() *TJPEGImage {
    j := new(TJPEGImage)
    j.instance = JPEGImage_Create()
    j.ptr = unsafe.Pointer(j.instance)
    // 不敢启用，因为不知道会发生什么...
    // runtime.SetFinalizer(j, (*TJPEGImage).Free)
    return j
}

// CN: 动态转换一个已存在的对象实例。或者使用Obj.As().<目标对象>。
// EN: Dynamically convert an existing object instance. Or use Obj.As().<Target object>.
func AsJPEGImage(obj interface{}) *TJPEGImage {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TJPEGImage{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// CN: 新建一个对象来自已经存在的对象实例指针。
// EN: Create a new object from an existing object instance pointer.
// Deprecated: use AsJPEGImage.
func JPEGImageFromInst(inst uintptr) *TJPEGImage {
    return AsJPEGImage(inst)
}

// CN: 新建一个对象来自已经存在的对象实例。
// EN: Create a new object from an existing object instance.
// Deprecated: use AsJPEGImage.
func JPEGImageFromObj(obj IObject) *TJPEGImage {
    return AsJPEGImage(obj)
}

// CN: 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// EN: Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsJPEGImage.
func JPEGImageFromUnsafePointer(ptr unsafe.Pointer) *TJPEGImage {
    return AsJPEGImage(ptr)
}

// -------------------------- Deprecated end --------------------------
// CN: 释放对象。
// EN: Free object.
func (j *TJPEGImage) Free() {
    if j.instance != 0 {
        JPEGImage_Free(j.instance)
        j.instance, j.ptr = 0, nullptr
    }
}

// CN: 返回对象实例指针。
// EN: Return object instance pointer.
func (j *TJPEGImage) Instance() uintptr {
    return j.instance
}

// CN: 获取一个不安全的地址。
// EN: Get an unsafe address.
func (j *TJPEGImage) UnsafeAddr() unsafe.Pointer {
    return j.ptr
}

// CN: 检测地址是否为空。
// EN: Check if the address is empty.
func (j *TJPEGImage) IsValid() bool {
    return j.instance != 0
}

// CN: 检测当前对象是否继承自目标对象。
// EN: Checks whether the current object is inherited from the target object.
func (j *TJPEGImage) Is() TIs {
    return TIs(j.instance)
}

// CN: 动态转换当前对象为目标对象。
// EN: Dynamically convert the current object to the target object.
//func (j *TJPEGImage) As() TAs {
//    return TAs(j.instance)
//}

// CN: 获取类信息指针。
// EN: Get class information pointer.
func TJPEGImageClass() TClass {
    return JPEGImage_StaticClassType()
}

// CN: 复制一个对象，如果对象实现了此方法的话。
// EN: Copy an object, if the object implements this method.
func (j *TJPEGImage) Assign(Source IObject) {
    JPEGImage_Assign(j.instance, CheckPtr(Source))
}

// CN: 文件流加载。
// EN: .
func (j *TJPEGImage) LoadFromStream(Stream IObject) {
    JPEGImage_LoadFromStream(j.instance, CheckPtr(Stream))
}

// CN: 保存至流。
// EN: .
func (j *TJPEGImage) SaveToStream(Stream IObject) {
    JPEGImage_SaveToStream(j.instance, CheckPtr(Stream))
}

// CN: 与一个对象进行比较。
// EN: Compare with an object.
func (j *TJPEGImage) Equals(Obj IObject) bool {
    return JPEGImage_Equals(j.instance, CheckPtr(Obj))
}

// CN: 从文件加载。
// EN: .
func (j *TJPEGImage) LoadFromFile(Filename string) {
    JPEGImage_LoadFromFile(j.instance, Filename)
}

// CN: 保存至文件。
// EN: .
func (j *TJPEGImage) SaveToFile(Filename string) {
    JPEGImage_SaveToFile(j.instance, Filename)
}

func (j *TJPEGImage) SetSize(AWidth int32, AHeight int32) {
    JPEGImage_SetSize(j.instance, AWidth , AHeight)
}

// CN: 获取类名路径。
// EN: Get the class name path.
func (j *TJPEGImage) GetNamePath() string {
    return JPEGImage_GetNamePath(j.instance)
}

// CN: 获取类的类型信息。
// EN: Get class type information.
func (j *TJPEGImage) ClassType() TClass {
    return JPEGImage_ClassType(j.instance)
}

// CN: 获取当前对象类名称。
// EN: Get the current object class name.
func (j *TJPEGImage) ClassName() string {
    return JPEGImage_ClassName(j.instance)
}

// CN: 获取当前对象实例大小。
// EN: Get the current object instance size.
func (j *TJPEGImage) InstanceSize() int32 {
    return JPEGImage_InstanceSize(j.instance)
}

// CN: 判断当前类是否继承自指定类。
// EN: Determine whether the current class inherits from the specified class.
func (j *TJPEGImage) InheritsFrom(AClass TClass) bool {
    return JPEGImage_InheritsFrom(j.instance, AClass)
}

// CN: 获取类的哈希值。
// EN: Get the hash value of the class.
func (j *TJPEGImage) GetHashCode() int32 {
    return JPEGImage_GetHashCode(j.instance)
}

// CN: 文本类信息。
// EN: Text information.
func (j *TJPEGImage) ToString() string {
    return JPEGImage_ToString(j.instance)
}

func (j *TJPEGImage) PixelFormat() TJPEGPixelFormat {
    return JPEGImage_GetPixelFormat(j.instance)
}

func (j *TJPEGImage) SetPixelFormat(value TJPEGPixelFormat) {
    JPEGImage_SetPixelFormat(j.instance, value)
}

func (j *TJPEGImage) Performance() TJPEGPerformance {
    return JPEGImage_GetPerformance(j.instance)
}

func (j *TJPEGImage) SetPerformance(value TJPEGPerformance) {
    JPEGImage_SetPerformance(j.instance, value)
}

// CN: 获取画布。
// EN: .
func (j *TJPEGImage) Canvas() *TCanvas {
    return AsCanvas(JPEGImage_GetCanvas(j.instance))
}

func (j *TJPEGImage) Empty() bool {
    return JPEGImage_GetEmpty(j.instance)
}

// CN: 获取高度。
// EN: Get height.
func (j *TJPEGImage) Height() int32 {
    return JPEGImage_GetHeight(j.instance)
}

// CN: 设置高度。
// EN: Set height.
func (j *TJPEGImage) SetHeight(value int32) {
    JPEGImage_SetHeight(j.instance, value)
}

// CN: 获取修改。
// EN: Get modified.
func (j *TJPEGImage) Modified() bool {
    return JPEGImage_GetModified(j.instance)
}

// CN: 设置修改。
// EN: Set modified.
func (j *TJPEGImage) SetModified(value bool) {
    JPEGImage_SetModified(j.instance, value)
}

func (j *TJPEGImage) Palette() HPALETTE {
    return JPEGImage_GetPalette(j.instance)
}

func (j *TJPEGImage) SetPalette(value HPALETTE) {
    JPEGImage_SetPalette(j.instance, value)
}

func (j *TJPEGImage) PaletteModified() bool {
    return JPEGImage_GetPaletteModified(j.instance)
}

func (j *TJPEGImage) SetPaletteModified(value bool) {
    JPEGImage_SetPaletteModified(j.instance, value)
}

// CN: 获取透明。
// EN: Get transparent.
func (j *TJPEGImage) Transparent() bool {
    return JPEGImage_GetTransparent(j.instance)
}

// CN: 设置透明。
// EN: Set transparent.
func (j *TJPEGImage) SetTransparent(value bool) {
    JPEGImage_SetTransparent(j.instance, value)
}

// CN: 获取宽度。
// EN: Get width.
func (j *TJPEGImage) Width() int32 {
    return JPEGImage_GetWidth(j.instance)
}

// CN: 设置宽度。
// EN: Set width.
func (j *TJPEGImage) SetWidth(value int32) {
    JPEGImage_SetWidth(j.instance, value)
}

// CN: 设置改变事件。
// EN: Set changed event.
func (j *TJPEGImage) SetOnChange(fn TNotifyEvent) {
    JPEGImage_SetOnChange(j.instance, fn)
}

