
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TLabeledEdit struct {
    IWinControl
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// CN: 创建一个新的对象。
// EN: Create a new object.
func NewLabeledEdit(owner IComponent) *TLabeledEdit {
    l := new(TLabeledEdit)
    l.instance = LabeledEdit_Create(CheckPtr(owner))
    l.ptr = unsafe.Pointer(l.instance)
    // 不敢启用，因为不知道会发生什么...
    // runtime.SetFinalizer(l, (*TLabeledEdit).Free)
    return l
}

// CN: 动态转换一个已存在的对象实例。或者使用Obj.As().<目标对象>。
// EN: Dynamically convert an existing object instance. Or use Obj.As().<Target object>.
func AsLabeledEdit(obj interface{}) *TLabeledEdit {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TLabeledEdit{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// CN: 新建一个对象来自已经存在的对象实例指针。
// EN: Create a new object from an existing object instance pointer.
// Deprecated: use AsLabeledEdit.
func LabeledEditFromInst(inst uintptr) *TLabeledEdit {
    return AsLabeledEdit(inst)
}

// CN: 新建一个对象来自已经存在的对象实例。
// EN: Create a new object from an existing object instance.
// Deprecated: use AsLabeledEdit.
func LabeledEditFromObj(obj IObject) *TLabeledEdit {
    return AsLabeledEdit(obj)
}

// CN: 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// EN: Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsLabeledEdit.
func LabeledEditFromUnsafePointer(ptr unsafe.Pointer) *TLabeledEdit {
    return AsLabeledEdit(ptr)
}

// -------------------------- Deprecated end --------------------------
// CN: 释放对象。
// EN: Free object.
func (l *TLabeledEdit) Free() {
    if l.instance != 0 {
        LabeledEdit_Free(l.instance)
        l.instance, l.ptr = 0, nullptr
    }
}

// CN: 返回对象实例指针。
// EN: Return object instance pointer.
func (l *TLabeledEdit) Instance() uintptr {
    return l.instance
}

// CN: 获取一个不安全的地址。
// EN: Get an unsafe address.
func (l *TLabeledEdit) UnsafeAddr() unsafe.Pointer {
    return l.ptr
}

// CN: 检测地址是否为空。
// EN: Check if the address is empty.
func (l *TLabeledEdit) IsValid() bool {
    return l.instance != 0
}

// CN: 检测当前对象是否继承自目标对象。
// EN: Checks whether the current object is inherited from the target object.
func (l *TLabeledEdit) Is() TIs {
    return TIs(l.instance)
}

// CN: 动态转换当前对象为目标对象。
// EN: Dynamically convert the current object to the target object.
//func (l *TLabeledEdit) As() TAs {
//    return TAs(l.instance)
//}

// CN: 获取类信息指针。
// EN: Get class information pointer.
func TLabeledEditClass() TClass {
    return LabeledEdit_StaticClassType()
}

// CN: 设置组件边界。
// EN: Set component boundaries.
func (l *TLabeledEdit) SetBounds(ALeft int32, ATop int32, AWidth int32, AHeight int32) {
    LabeledEdit_SetBounds(l.instance, ALeft , ATop , AWidth , AHeight)
}

// CN: 清除。
// EN: .
func (l *TLabeledEdit) Clear() {
    LabeledEdit_Clear(l.instance)
}

// CN: 清除选择。
// EN: .
func (l *TLabeledEdit) ClearSelection() {
    LabeledEdit_ClearSelection(l.instance)
}

// CN: 复制到粘贴板。
// EN: .
func (l *TLabeledEdit) CopyToClipboard() {
    LabeledEdit_CopyToClipboard(l.instance)
}

// CN: 剪切到粘贴板。
// EN: .
func (l *TLabeledEdit) CutToClipboard() {
    LabeledEdit_CutToClipboard(l.instance)
}

// CN: 从剪切板粘贴。
// EN: .
func (l *TLabeledEdit) PasteFromClipboard() {
    LabeledEdit_PasteFromClipboard(l.instance)
}

// CN: 撤销上一次操作。
// EN: .
func (l *TLabeledEdit) Undo() {
    LabeledEdit_Undo(l.instance)
}

// CN: 全选。
// EN: .
func (l *TLabeledEdit) SelectAll() {
    LabeledEdit_SelectAll(l.instance)
}

// CN: 是否可以获得焦点。
// EN: .
func (l *TLabeledEdit) CanFocus() bool {
    return LabeledEdit_CanFocus(l.instance)
}

// CN: 返回是否包含指定控件。
// EN: it's contain a specified control.
func (l *TLabeledEdit) ContainsControl(Control IControl) bool {
    return LabeledEdit_ContainsControl(l.instance, CheckPtr(Control))
}

// CN: 返回指定坐标及相关属性位置控件。
// EN: Returns the specified coordinate and the relevant attribute position control..
func (l *TLabeledEdit) ControlAtPos(Pos TPoint, AllowDisabled bool, AllowWinControls bool, AllLevels bool) *TControl {
    return AsControl(LabeledEdit_ControlAtPos(l.instance, Pos , AllowDisabled , AllowWinControls , AllLevels))
}

// CN: 禁用控件的对齐。
// EN: Disable control alignment.
func (l *TLabeledEdit) DisableAlign() {
    LabeledEdit_DisableAlign(l.instance)
}

// CN: 启用控件对齐。
// EN: Enabled control alignment.
func (l *TLabeledEdit) EnableAlign() {
    LabeledEdit_EnableAlign(l.instance)
}

// CN: 查找子控件。
// EN: Find sub controls.
func (l *TLabeledEdit) FindChildControl(ControlName string) *TControl {
    return AsControl(LabeledEdit_FindChildControl(l.instance, ControlName))
}

func (l *TLabeledEdit) FlipChildren(AllLevels bool) {
    LabeledEdit_FlipChildren(l.instance, AllLevels)
}

// CN: 返回是否获取焦点。
// EN: Return to get focus.
func (l *TLabeledEdit) Focused() bool {
    return LabeledEdit_Focused(l.instance)
}

// CN: 句柄是否已经分配。
// EN: Is the handle already allocated.
func (l *TLabeledEdit) HandleAllocated() bool {
    return LabeledEdit_HandleAllocated(l.instance)
}

// CN: 插入一个控件。
// EN: Insert a control.
func (l *TLabeledEdit) InsertControl(AControl IControl) {
    LabeledEdit_InsertControl(l.instance, CheckPtr(AControl))
}

// CN: 要求重绘。
// EN: Redraw.
func (l *TLabeledEdit) Invalidate() {
    LabeledEdit_Invalidate(l.instance)
}

// CN: 移除一个控件。
// EN: Remove a control.
func (l *TLabeledEdit) RemoveControl(AControl IControl) {
    LabeledEdit_RemoveControl(l.instance, CheckPtr(AControl))
}

// CN: 重新对齐。
// EN: Realign.
func (l *TLabeledEdit) Realign() {
    LabeledEdit_Realign(l.instance)
}

// CN: 重绘。
// EN: Repaint.
func (l *TLabeledEdit) Repaint() {
    LabeledEdit_Repaint(l.instance)
}

// CN: 按比例缩放。
// EN: Scale by.
func (l *TLabeledEdit) ScaleBy(M int32, D int32) {
    LabeledEdit_ScaleBy(l.instance, M , D)
}

// CN: 滚动至指定位置。
// EN: Scroll by.
func (l *TLabeledEdit) ScrollBy(DeltaX int32, DeltaY int32) {
    LabeledEdit_ScrollBy(l.instance, DeltaX , DeltaY)
}

// CN: 设置控件焦点。
// EN: Set control focus.
func (l *TLabeledEdit) SetFocus() {
    LabeledEdit_SetFocus(l.instance)
}

// CN: 控件更新。
// EN: Update.
func (l *TLabeledEdit) Update() {
    LabeledEdit_Update(l.instance)
}

// CN: 将控件置于最前。
// EN: Bring the control to the front.
func (l *TLabeledEdit) BringToFront() {
    LabeledEdit_BringToFront(l.instance)
}

// CN: 将客户端坐标转为绝对的屏幕坐标。
// EN: Convert client coordinates to absolute screen coordinates.
func (l *TLabeledEdit) ClientToScreen(Point TPoint) TPoint {
    return LabeledEdit_ClientToScreen(l.instance, Point)
}

// CN: 将客户端坐标转为父容器坐标。
// EN: Convert client coordinates to parent container coordinates.
func (l *TLabeledEdit) ClientToParent(Point TPoint, AParent IWinControl) TPoint {
    return LabeledEdit_ClientToParent(l.instance, Point , CheckPtr(AParent))
}

// CN: 是否在拖拽中。
// EN: Is it in the middle of dragging.
func (l *TLabeledEdit) Dragging() bool {
    return LabeledEdit_Dragging(l.instance)
}

// CN: 是否有父容器。
// EN: Is there a parent container.
func (l *TLabeledEdit) HasParent() bool {
    return LabeledEdit_HasParent(l.instance)
}

// CN: 隐藏控件。
// EN: Hidden control.
func (l *TLabeledEdit) Hide() {
    LabeledEdit_Hide(l.instance)
}

// CN: 发送一个消息。
// EN: Send a message.
func (l *TLabeledEdit) Perform(Msg uint32, WParam uintptr, LParam int) int {
    return LabeledEdit_Perform(l.instance, Msg , WParam , LParam)
}

// CN: 刷新控件。
// EN: Refresh control.
func (l *TLabeledEdit) Refresh() {
    LabeledEdit_Refresh(l.instance)
}

// CN: 将屏幕坐标转为客户端坐标。
// EN: Convert screen coordinates to client coordinates.
func (l *TLabeledEdit) ScreenToClient(Point TPoint) TPoint {
    return LabeledEdit_ScreenToClient(l.instance, Point)
}

// CN: 将父容器坐标转为客户端坐标。
// EN: Convert parent container coordinates to client coordinates.
func (l *TLabeledEdit) ParentToClient(Point TPoint, AParent IWinControl) TPoint {
    return LabeledEdit_ParentToClient(l.instance, Point , CheckPtr(AParent))
}

// CN: 控件至于最后面。
// EN: The control is placed at the end.
func (l *TLabeledEdit) SendToBack() {
    LabeledEdit_SendToBack(l.instance)
}

// CN: 显示控件。
// EN: Show control.
func (l *TLabeledEdit) Show() {
    LabeledEdit_Show(l.instance)
}

// CN: 获取控件的字符，如果有。
// EN: Get the characters of the control, if any.
func (l *TLabeledEdit) GetTextBuf(Buffer *string, BufSize int32) int32 {
    return LabeledEdit_GetTextBuf(l.instance, Buffer , BufSize)
}

// CN: 获取控件的字符长，如果有。
// EN: Get the character length of the control, if any.
func (l *TLabeledEdit) GetTextLen() int32 {
    return LabeledEdit_GetTextLen(l.instance)
}

// CN: 设置控件字符，如果有。
// EN: Set control characters, if any.
func (l *TLabeledEdit) SetTextBuf(Buffer string) {
    LabeledEdit_SetTextBuf(l.instance, Buffer)
}

// CN: 查找指定名称的组件。
// EN: Find the component with the specified name.
func (l *TLabeledEdit) FindComponent(AName string) *TComponent {
    return AsComponent(LabeledEdit_FindComponent(l.instance, AName))
}

// CN: 获取类名路径。
// EN: Get the class name path.
func (l *TLabeledEdit) GetNamePath() string {
    return LabeledEdit_GetNamePath(l.instance)
}

// CN: 复制一个对象，如果对象实现了此方法的话。
// EN: Copy an object, if the object implements this method.
func (l *TLabeledEdit) Assign(Source IObject) {
    LabeledEdit_Assign(l.instance, CheckPtr(Source))
}

// CN: 获取类的类型信息。
// EN: Get class type information.
func (l *TLabeledEdit) ClassType() TClass {
    return LabeledEdit_ClassType(l.instance)
}

// CN: 获取当前对象类名称。
// EN: Get the current object class name.
func (l *TLabeledEdit) ClassName() string {
    return LabeledEdit_ClassName(l.instance)
}

// CN: 获取当前对象实例大小。
// EN: Get the current object instance size.
func (l *TLabeledEdit) InstanceSize() int32 {
    return LabeledEdit_InstanceSize(l.instance)
}

// CN: 判断当前类是否继承自指定类。
// EN: Determine whether the current class inherits from the specified class.
func (l *TLabeledEdit) InheritsFrom(AClass TClass) bool {
    return LabeledEdit_InheritsFrom(l.instance, AClass)
}

// CN: 与一个对象进行比较。
// EN: Compare with an object.
func (l *TLabeledEdit) Equals(Obj IObject) bool {
    return LabeledEdit_Equals(l.instance, CheckPtr(Obj))
}

// CN: 获取类的哈希值。
// EN: Get the hash value of the class.
func (l *TLabeledEdit) GetHashCode() int32 {
    return LabeledEdit_GetHashCode(l.instance)
}

// CN: 文本类信息。
// EN: Text information.
func (l *TLabeledEdit) ToString() string {
    return LabeledEdit_ToString(l.instance)
}

func (l *TLabeledEdit) AnchorToNeighbour(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    LabeledEdit_AnchorToNeighbour(l.instance, ASide , ASpace , CheckPtr(ASibling))
}

func (l *TLabeledEdit) AnchorParallel(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    LabeledEdit_AnchorParallel(l.instance, ASide , ASpace , CheckPtr(ASibling))
}

// CN: 置于指定控件的横向中心。
// EN: .
func (l *TLabeledEdit) AnchorHorizontalCenterTo(ASibling IControl) {
    LabeledEdit_AnchorHorizontalCenterTo(l.instance, CheckPtr(ASibling))
}

// CN: 置于指定控件的纵向中心。
// EN: .
func (l *TLabeledEdit) AnchorVerticalCenterTo(ASibling IControl) {
    LabeledEdit_AnchorVerticalCenterTo(l.instance, CheckPtr(ASibling))
}

func (l *TLabeledEdit) AnchorAsAlign(ATheAlign TAlign, ASpace int32) {
    LabeledEdit_AnchorAsAlign(l.instance, ATheAlign , ASpace)
}

func (l *TLabeledEdit) AnchorClient(ASpace int32) {
    LabeledEdit_AnchorClient(l.instance, ASpace)
}

// CN: 获取文字对齐。
// EN: Get Text alignment.
func (l *TLabeledEdit) Alignment() TAlignment {
    return LabeledEdit_GetAlignment(l.instance)
}

// CN: 设置文字对齐。
// EN: Set Text alignment.
func (l *TLabeledEdit) SetAlignment(value TAlignment) {
    LabeledEdit_SetAlignment(l.instance, value)
}

// CN: 获取四个角位置的锚点。
// EN: .
func (l *TLabeledEdit) Anchors() TAnchors {
    return LabeledEdit_GetAnchors(l.instance)
}

// CN: 设置四个角位置的锚点。
// EN: .
func (l *TLabeledEdit) SetAnchors(value TAnchors) {
    LabeledEdit_SetAnchors(l.instance, value)
}

// CN: 获取自动选择。
// EN: .
func (l *TLabeledEdit) AutoSelect() bool {
    return LabeledEdit_GetAutoSelect(l.instance)
}

// CN: 设置自动选择。
// EN: .
func (l *TLabeledEdit) SetAutoSelect(value bool) {
    LabeledEdit_SetAutoSelect(l.instance, value)
}

// CN: 获取自动调整大小。
// EN: .
func (l *TLabeledEdit) AutoSize() bool {
    return LabeledEdit_GetAutoSize(l.instance)
}

// CN: 设置自动调整大小。
// EN: .
func (l *TLabeledEdit) SetAutoSize(value bool) {
    LabeledEdit_SetAutoSize(l.instance, value)
}

func (l *TLabeledEdit) BiDiMode() TBiDiMode {
    return LabeledEdit_GetBiDiMode(l.instance)
}

func (l *TLabeledEdit) SetBiDiMode(value TBiDiMode) {
    LabeledEdit_SetBiDiMode(l.instance, value)
}

// CN: 获取窗口边框样式。比如：无边框，单一边框等。
// EN: .
func (l *TLabeledEdit) BorderStyle() TBorderStyle {
    return LabeledEdit_GetBorderStyle(l.instance)
}

// CN: 设置窗口边框样式。比如：无边框，单一边框等。
// EN: .
func (l *TLabeledEdit) SetBorderStyle(value TBorderStyle) {
    LabeledEdit_SetBorderStyle(l.instance, value)
}

func (l *TLabeledEdit) CharCase() TEditCharCase {
    return LabeledEdit_GetCharCase(l.instance)
}

func (l *TLabeledEdit) SetCharCase(value TEditCharCase) {
    LabeledEdit_SetCharCase(l.instance, value)
}

// CN: 获取颜色。
// EN: Get color.
func (l *TLabeledEdit) Color() TColor {
    return LabeledEdit_GetColor(l.instance)
}

// CN: 设置颜色。
// EN: Set color.
func (l *TLabeledEdit) SetColor(value TColor) {
    LabeledEdit_SetColor(l.instance, value)
}

// CN: 获取约束控件大小。
// EN: .
func (l *TLabeledEdit) Constraints() *TSizeConstraints {
    return AsSizeConstraints(LabeledEdit_GetConstraints(l.instance))
}

// CN: 设置约束控件大小。
// EN: .
func (l *TLabeledEdit) SetConstraints(value *TSizeConstraints) {
    LabeledEdit_SetConstraints(l.instance, CheckPtr(value))
}

// CN: 获取设置控件双缓冲。
// EN: Get Set control double buffering.
func (l *TLabeledEdit) DoubleBuffered() bool {
    return LabeledEdit_GetDoubleBuffered(l.instance)
}

// CN: 设置设置控件双缓冲。
// EN: Set Set control double buffering.
func (l *TLabeledEdit) SetDoubleBuffered(value bool) {
    LabeledEdit_SetDoubleBuffered(l.instance, value)
}

// CN: 获取设置控件拖拽时的光标。
// EN: Get Set the cursor when the control is dragged.
func (l *TLabeledEdit) DragCursor() TCursor {
    return LabeledEdit_GetDragCursor(l.instance)
}

// CN: 设置设置控件拖拽时的光标。
// EN: Set Set the cursor when the control is dragged.
func (l *TLabeledEdit) SetDragCursor(value TCursor) {
    LabeledEdit_SetDragCursor(l.instance, value)
}

// CN: 获取拖拽模式。
// EN: Get Drag mode.
func (l *TLabeledEdit) DragMode() TDragMode {
    return LabeledEdit_GetDragMode(l.instance)
}

// CN: 设置拖拽模式。
// EN: Set Drag mode.
func (l *TLabeledEdit) SetDragMode(value TDragMode) {
    LabeledEdit_SetDragMode(l.instance, value)
}

func (l *TLabeledEdit) EditLabel() *TBoundLabel {
    return AsBoundLabel(LabeledEdit_GetEditLabel(l.instance))
}

// CN: 获取控件启用。
// EN: Get the control enabled.
func (l *TLabeledEdit) Enabled() bool {
    return LabeledEdit_GetEnabled(l.instance)
}

// CN: 设置控件启用。
// EN: Set the control enabled.
func (l *TLabeledEdit) SetEnabled(value bool) {
    LabeledEdit_SetEnabled(l.instance, value)
}

// CN: 获取字体。
// EN: Get Font.
func (l *TLabeledEdit) Font() *TFont {
    return AsFont(LabeledEdit_GetFont(l.instance))
}

// CN: 设置字体。
// EN: Set Font.
func (l *TLabeledEdit) SetFont(value *TFont) {
    LabeledEdit_SetFont(l.instance, CheckPtr(value))
}

// CN: 获取隐藏选择。
// EN: .
func (l *TLabeledEdit) HideSelection() bool {
    return LabeledEdit_GetHideSelection(l.instance)
}

// CN: 设置隐藏选择。
// EN: .
func (l *TLabeledEdit) SetHideSelection(value bool) {
    LabeledEdit_SetHideSelection(l.instance, value)
}

func (l *TLabeledEdit) LabelPosition() TLabelPosition {
    return LabeledEdit_GetLabelPosition(l.instance)
}

func (l *TLabeledEdit) SetLabelPosition(value TLabelPosition) {
    LabeledEdit_SetLabelPosition(l.instance, value)
}

func (l *TLabeledEdit) LabelSpacing() int32 {
    return LabeledEdit_GetLabelSpacing(l.instance)
}

func (l *TLabeledEdit) SetLabelSpacing(value int32) {
    LabeledEdit_SetLabelSpacing(l.instance, value)
}

// CN: 获取最大长度。
// EN: .
func (l *TLabeledEdit) MaxLength() int32 {
    return LabeledEdit_GetMaxLength(l.instance)
}

// CN: 设置最大长度。
// EN: .
func (l *TLabeledEdit) SetMaxLength(value int32) {
    LabeledEdit_SetMaxLength(l.instance, value)
}

// CN: 获取只能输入数字。
// EN: .
func (l *TLabeledEdit) NumbersOnly() bool {
    return LabeledEdit_GetNumbersOnly(l.instance)
}

// CN: 设置只能输入数字。
// EN: .
func (l *TLabeledEdit) SetNumbersOnly(value bool) {
    LabeledEdit_SetNumbersOnly(l.instance, value)
}

// CN: 获取父容器颜色。
// EN: Get parent color.
func (l *TLabeledEdit) ParentColor() bool {
    return LabeledEdit_GetParentColor(l.instance)
}

// CN: 设置父容器颜色。
// EN: Set parent color.
func (l *TLabeledEdit) SetParentColor(value bool) {
    LabeledEdit_SetParentColor(l.instance, value)
}

// CN: 获取父容器双缓冲。
// EN: Get Parent container double buffering.
func (l *TLabeledEdit) ParentDoubleBuffered() bool {
    return LabeledEdit_GetParentDoubleBuffered(l.instance)
}

// CN: 设置父容器双缓冲。
// EN: Set Parent container double buffering.
func (l *TLabeledEdit) SetParentDoubleBuffered(value bool) {
    LabeledEdit_SetParentDoubleBuffered(l.instance, value)
}

// CN: 获取父容器字体。
// EN: Get Parent container font.
func (l *TLabeledEdit) ParentFont() bool {
    return LabeledEdit_GetParentFont(l.instance)
}

// CN: 设置父容器字体。
// EN: Set Parent container font.
func (l *TLabeledEdit) SetParentFont(value bool) {
    LabeledEdit_SetParentFont(l.instance, value)
}

// CN: 获取以父容器的ShowHint属性为准。
// EN: .
func (l *TLabeledEdit) ParentShowHint() bool {
    return LabeledEdit_GetParentShowHint(l.instance)
}

// CN: 设置以父容器的ShowHint属性为准。
// EN: .
func (l *TLabeledEdit) SetParentShowHint(value bool) {
    LabeledEdit_SetParentShowHint(l.instance, value)
}

// CN: 获取密码掩码字符。
// EN: .
func (l *TLabeledEdit) PasswordChar() uint16 {
    return LabeledEdit_GetPasswordChar(l.instance)
}

// CN: 设置密码掩码字符。
// EN: .
func (l *TLabeledEdit) SetPasswordChar(value uint16) {
    LabeledEdit_SetPasswordChar(l.instance, value)
}

// CN: 获取右键菜单。
// EN: Get Right click menu.
func (l *TLabeledEdit) PopupMenu() *TPopupMenu {
    return AsPopupMenu(LabeledEdit_GetPopupMenu(l.instance))
}

// CN: 设置右键菜单。
// EN: Set Right click menu.
func (l *TLabeledEdit) SetPopupMenu(value IComponent) {
    LabeledEdit_SetPopupMenu(l.instance, CheckPtr(value))
}

// CN: 获取只读。
// EN: .
func (l *TLabeledEdit) ReadOnly() bool {
    return LabeledEdit_GetReadOnly(l.instance)
}

// CN: 设置只读。
// EN: .
func (l *TLabeledEdit) SetReadOnly(value bool) {
    LabeledEdit_SetReadOnly(l.instance, value)
}

// CN: 获取显示鼠标悬停提示。
// EN: Get Show mouseover tips.
func (l *TLabeledEdit) ShowHint() bool {
    return LabeledEdit_GetShowHint(l.instance)
}

// CN: 设置显示鼠标悬停提示。
// EN: Set Show mouseover tips.
func (l *TLabeledEdit) SetShowHint(value bool) {
    LabeledEdit_SetShowHint(l.instance, value)
}

// CN: 获取Tab切换顺序序号。
// EN: Get Tab switching sequence number.
func (l *TLabeledEdit) TabOrder() TTabOrder {
    return LabeledEdit_GetTabOrder(l.instance)
}

// CN: 设置Tab切换顺序序号。
// EN: Set Tab switching sequence number.
func (l *TLabeledEdit) SetTabOrder(value TTabOrder) {
    LabeledEdit_SetTabOrder(l.instance, value)
}

// CN: 获取Tab可停留。
// EN: Get Tab can stay.
func (l *TLabeledEdit) TabStop() bool {
    return LabeledEdit_GetTabStop(l.instance)
}

// CN: 设置Tab可停留。
// EN: Set Tab can stay.
func (l *TLabeledEdit) SetTabStop(value bool) {
    LabeledEdit_SetTabStop(l.instance, value)
}

// CN: 获取文本。
// EN: .
func (l *TLabeledEdit) Text() string {
    strLen := l.GetTextLen()
    if strLen != 0 {
        var buffStr string
        l.GetTextBuf(&buffStr, strLen + 1)
        return buffStr
    }
    return ""
}

// CN: 设置文本。
// EN: .
func (l *TLabeledEdit) SetText(value string) {
    LabeledEdit_SetText(l.instance, value)
}

// CN: 获取提示文本。
// EN: .
func (l *TLabeledEdit) TextHint() string {
    return LabeledEdit_GetTextHint(l.instance)
}

// CN: 设置提示文本。
// EN: .
func (l *TLabeledEdit) SetTextHint(value string) {
    LabeledEdit_SetTextHint(l.instance, value)
}

// CN: 获取控件可视。
// EN: Get the control visible.
func (l *TLabeledEdit) Visible() bool {
    return LabeledEdit_GetVisible(l.instance)
}

// CN: 设置控件可视。
// EN: Set the control visible.
func (l *TLabeledEdit) SetVisible(value bool) {
    LabeledEdit_SetVisible(l.instance, value)
}

// CN: 设置改变事件。
// EN: Set changed event.
func (l *TLabeledEdit) SetOnChange(fn TNotifyEvent) {
    LabeledEdit_SetOnChange(l.instance, fn)
}

// CN: 设置控件单击事件。
// EN: Set control click event.
func (l *TLabeledEdit) SetOnClick(fn TNotifyEvent) {
    LabeledEdit_SetOnClick(l.instance, fn)
}

// CN: 设置双击事件。
// EN: .
func (l *TLabeledEdit) SetOnDblClick(fn TNotifyEvent) {
    LabeledEdit_SetOnDblClick(l.instance, fn)
}

// CN: 设置拖拽下落事件。
// EN: Set Drag and drop event.
func (l *TLabeledEdit) SetOnDragDrop(fn TDragDropEvent) {
    LabeledEdit_SetOnDragDrop(l.instance, fn)
}

// CN: 设置拖拽完成事件。
// EN: Set Drag and drop completion event.
func (l *TLabeledEdit) SetOnDragOver(fn TDragOverEvent) {
    LabeledEdit_SetOnDragOver(l.instance, fn)
}

// CN: 设置拖拽结束。
// EN: Set End of drag.
func (l *TLabeledEdit) SetOnEndDrag(fn TEndDragEvent) {
    LabeledEdit_SetOnEndDrag(l.instance, fn)
}

// CN: 设置焦点进入。
// EN: Set Focus entry.
func (l *TLabeledEdit) SetOnEnter(fn TNotifyEvent) {
    LabeledEdit_SetOnEnter(l.instance, fn)
}

// CN: 设置焦点退出。
// EN: Set Focus exit.
func (l *TLabeledEdit) SetOnExit(fn TNotifyEvent) {
    LabeledEdit_SetOnExit(l.instance, fn)
}

// CN: 设置键盘按键按下事件。
// EN: Set Keyboard button press event.
func (l *TLabeledEdit) SetOnKeyDown(fn TKeyEvent) {
    LabeledEdit_SetOnKeyDown(l.instance, fn)
}

func (l *TLabeledEdit) SetOnKeyPress(fn TKeyPressEvent) {
    LabeledEdit_SetOnKeyPress(l.instance, fn)
}

// CN: 设置键盘按键抬起事件。
// EN: Set Keyboard button lift event.
func (l *TLabeledEdit) SetOnKeyUp(fn TKeyEvent) {
    LabeledEdit_SetOnKeyUp(l.instance, fn)
}

// CN: 设置鼠标按下事件。
// EN: Set Mouse down event.
func (l *TLabeledEdit) SetOnMouseDown(fn TMouseEvent) {
    LabeledEdit_SetOnMouseDown(l.instance, fn)
}

// CN: 设置鼠标进入事件。
// EN: Set Mouse entry event.
func (l *TLabeledEdit) SetOnMouseEnter(fn TNotifyEvent) {
    LabeledEdit_SetOnMouseEnter(l.instance, fn)
}

// CN: 设置鼠标离开事件。
// EN: Set Mouse leave event.
func (l *TLabeledEdit) SetOnMouseLeave(fn TNotifyEvent) {
    LabeledEdit_SetOnMouseLeave(l.instance, fn)
}

// CN: 设置鼠标移动事件。
// EN: .
func (l *TLabeledEdit) SetOnMouseMove(fn TMouseMoveEvent) {
    LabeledEdit_SetOnMouseMove(l.instance, fn)
}

// CN: 设置鼠标抬起事件。
// EN: Set Mouse lift event.
func (l *TLabeledEdit) SetOnMouseUp(fn TMouseEvent) {
    LabeledEdit_SetOnMouseUp(l.instance, fn)
}

// CN: 获取能否撤销。
// EN: .
func (l *TLabeledEdit) CanUndo() bool {
    return LabeledEdit_GetCanUndo(l.instance)
}

// CN: 获取修改。
// EN: Get modified.
func (l *TLabeledEdit) Modified() bool {
    return LabeledEdit_GetModified(l.instance)
}

// CN: 设置修改。
// EN: Set modified.
func (l *TLabeledEdit) SetModified(value bool) {
    LabeledEdit_SetModified(l.instance, value)
}

// CN: 获取选择的长度。
// EN: .
func (l *TLabeledEdit) SelLength() int32 {
    return LabeledEdit_GetSelLength(l.instance)
}

// CN: 设置选择的长度。
// EN: .
func (l *TLabeledEdit) SetSelLength(value int32) {
    LabeledEdit_SetSelLength(l.instance, value)
}

// CN: 获取选择的启始位置。
// EN: .
func (l *TLabeledEdit) SelStart() int32 {
    return LabeledEdit_GetSelStart(l.instance)
}

// CN: 设置选择的启始位置。
// EN: .
func (l *TLabeledEdit) SetSelStart(value int32) {
    LabeledEdit_SetSelStart(l.instance, value)
}

// CN: 获取选择的文本。
// EN: .
func (l *TLabeledEdit) SelText() string {
    return LabeledEdit_GetSelText(l.instance)
}

// CN: 设置选择的文本。
// EN: .
func (l *TLabeledEdit) SetSelText(value string) {
    LabeledEdit_SetSelText(l.instance, value)
}

// CN: 获取依靠客户端总数。
// EN: .
func (l *TLabeledEdit) DockClientCount() int32 {
    return LabeledEdit_GetDockClientCount(l.instance)
}

// CN: 获取停靠站点。
// EN: Get Docking site.
func (l *TLabeledEdit) DockSite() bool {
    return LabeledEdit_GetDockSite(l.instance)
}

// CN: 设置停靠站点。
// EN: Set Docking site.
func (l *TLabeledEdit) SetDockSite(value bool) {
    LabeledEdit_SetDockSite(l.instance, value)
}

// CN: 获取鼠标是否在客户端，仅VCL有效。
// EN: Get Whether the mouse is on the client, only VCL is valid.
func (l *TLabeledEdit) MouseInClient() bool {
    return LabeledEdit_GetMouseInClient(l.instance)
}

// CN: 获取当前停靠的可视总数。
// EN: Get The total number of visible calls currently docked.
func (l *TLabeledEdit) VisibleDockClientCount() int32 {
    return LabeledEdit_GetVisibleDockClientCount(l.instance)
}

// CN: 获取画刷对象。
// EN: Get Brush.
func (l *TLabeledEdit) Brush() *TBrush {
    return AsBrush(LabeledEdit_GetBrush(l.instance))
}

// CN: 获取子控件数。
// EN: Get Number of child controls.
func (l *TLabeledEdit) ControlCount() int32 {
    return LabeledEdit_GetControlCount(l.instance)
}

// CN: 获取控件句柄。
// EN: Get Control handle.
func (l *TLabeledEdit) Handle() HWND {
    return LabeledEdit_GetHandle(l.instance)
}

// CN: 获取父容器句柄。
// EN: Get Parent container handle.
func (l *TLabeledEdit) ParentWindow() HWND {
    return LabeledEdit_GetParentWindow(l.instance)
}

// CN: 设置父容器句柄。
// EN: Set Parent container handle.
func (l *TLabeledEdit) SetParentWindow(value HWND) {
    LabeledEdit_SetParentWindow(l.instance, value)
}

func (l *TLabeledEdit) Showing() bool {
    return LabeledEdit_GetShowing(l.instance)
}

// CN: 获取使用停靠管理。
// EN: .
func (l *TLabeledEdit) UseDockManager() bool {
    return LabeledEdit_GetUseDockManager(l.instance)
}

// CN: 设置使用停靠管理。
// EN: .
func (l *TLabeledEdit) SetUseDockManager(value bool) {
    LabeledEdit_SetUseDockManager(l.instance, value)
}

func (l *TLabeledEdit) Action() *TAction {
    return AsAction(LabeledEdit_GetAction(l.instance))
}

func (l *TLabeledEdit) SetAction(value IComponent) {
    LabeledEdit_SetAction(l.instance, CheckPtr(value))
}

// CN: 获取控件自动调整。
// EN: Get Control automatically adjusts.
func (l *TLabeledEdit) Align() TAlign {
    return LabeledEdit_GetAlign(l.instance)
}

// CN: 设置控件自动调整。
// EN: Set Control automatically adjusts.
func (l *TLabeledEdit) SetAlign(value TAlign) {
    LabeledEdit_SetAlign(l.instance, value)
}

func (l *TLabeledEdit) BoundsRect() TRect {
    return LabeledEdit_GetBoundsRect(l.instance)
}

func (l *TLabeledEdit) SetBoundsRect(value TRect) {
    LabeledEdit_SetBoundsRect(l.instance, value)
}

// CN: 获取客户区高度。
// EN: Get client height.
func (l *TLabeledEdit) ClientHeight() int32 {
    return LabeledEdit_GetClientHeight(l.instance)
}

// CN: 设置客户区高度。
// EN: Set client height.
func (l *TLabeledEdit) SetClientHeight(value int32) {
    LabeledEdit_SetClientHeight(l.instance, value)
}

func (l *TLabeledEdit) ClientOrigin() TPoint {
    return LabeledEdit_GetClientOrigin(l.instance)
}

// CN: 获取客户区矩形。
// EN: Get client rectangle.
func (l *TLabeledEdit) ClientRect() TRect {
    return LabeledEdit_GetClientRect(l.instance)
}

// CN: 获取客户区宽度。
// EN: Get client width.
func (l *TLabeledEdit) ClientWidth() int32 {
    return LabeledEdit_GetClientWidth(l.instance)
}

// CN: 设置客户区宽度。
// EN: Set client width.
func (l *TLabeledEdit) SetClientWidth(value int32) {
    LabeledEdit_SetClientWidth(l.instance, value)
}

// CN: 获取控件状态。
// EN: Get control state.
func (l *TLabeledEdit) ControlState() TControlState {
    return LabeledEdit_GetControlState(l.instance)
}

// CN: 设置控件状态。
// EN: Set control state.
func (l *TLabeledEdit) SetControlState(value TControlState) {
    LabeledEdit_SetControlState(l.instance, value)
}

// CN: 获取控件样式。
// EN: Get control style.
func (l *TLabeledEdit) ControlStyle() TControlStyle {
    return LabeledEdit_GetControlStyle(l.instance)
}

// CN: 设置控件样式。
// EN: Set control style.
func (l *TLabeledEdit) SetControlStyle(value TControlStyle) {
    LabeledEdit_SetControlStyle(l.instance, value)
}

func (l *TLabeledEdit) Floating() bool {
    return LabeledEdit_GetFloating(l.instance)
}

// CN: 获取控件父容器。
// EN: Get control parent container.
func (l *TLabeledEdit) Parent() *TWinControl {
    return AsWinControl(LabeledEdit_GetParent(l.instance))
}

// CN: 设置控件父容器。
// EN: Set control parent container.
func (l *TLabeledEdit) SetParent(value IWinControl) {
    LabeledEdit_SetParent(l.instance, CheckPtr(value))
}

// CN: 获取左边位置。
// EN: Get Left position.
func (l *TLabeledEdit) Left() int32 {
    return LabeledEdit_GetLeft(l.instance)
}

// CN: 设置左边位置。
// EN: Set Left position.
func (l *TLabeledEdit) SetLeft(value int32) {
    LabeledEdit_SetLeft(l.instance, value)
}

// CN: 获取顶边位置。
// EN: Get Top position.
func (l *TLabeledEdit) Top() int32 {
    return LabeledEdit_GetTop(l.instance)
}

// CN: 设置顶边位置。
// EN: Set Top position.
func (l *TLabeledEdit) SetTop(value int32) {
    LabeledEdit_SetTop(l.instance, value)
}

// CN: 获取宽度。
// EN: Get width.
func (l *TLabeledEdit) Width() int32 {
    return LabeledEdit_GetWidth(l.instance)
}

// CN: 设置宽度。
// EN: Set width.
func (l *TLabeledEdit) SetWidth(value int32) {
    LabeledEdit_SetWidth(l.instance, value)
}

// CN: 获取高度。
// EN: Get height.
func (l *TLabeledEdit) Height() int32 {
    return LabeledEdit_GetHeight(l.instance)
}

// CN: 设置高度。
// EN: Set height.
func (l *TLabeledEdit) SetHeight(value int32) {
    LabeledEdit_SetHeight(l.instance, value)
}

// CN: 获取控件光标。
// EN: Get control cursor.
func (l *TLabeledEdit) Cursor() TCursor {
    return LabeledEdit_GetCursor(l.instance)
}

// CN: 设置控件光标。
// EN: Set control cursor.
func (l *TLabeledEdit) SetCursor(value TCursor) {
    LabeledEdit_SetCursor(l.instance, value)
}

// CN: 获取组件鼠标悬停提示。
// EN: Get component mouse hints.
func (l *TLabeledEdit) Hint() string {
    return LabeledEdit_GetHint(l.instance)
}

// CN: 设置组件鼠标悬停提示。
// EN: Set component mouse hints.
func (l *TLabeledEdit) SetHint(value string) {
    LabeledEdit_SetHint(l.instance, value)
}

// CN: 获取组件总数。
// EN: Get the total number of components.
func (l *TLabeledEdit) ComponentCount() int32 {
    return LabeledEdit_GetComponentCount(l.instance)
}

// CN: 获取组件索引。
// EN: Get component index.
func (l *TLabeledEdit) ComponentIndex() int32 {
    return LabeledEdit_GetComponentIndex(l.instance)
}

// CN: 设置组件索引。
// EN: Set component index.
func (l *TLabeledEdit) SetComponentIndex(value int32) {
    LabeledEdit_SetComponentIndex(l.instance, value)
}

// CN: 获取组件所有者。
// EN: Get component owner.
func (l *TLabeledEdit) Owner() *TComponent {
    return AsComponent(LabeledEdit_GetOwner(l.instance))
}

// CN: 获取组件名称。
// EN: Get the component name.
func (l *TLabeledEdit) Name() string {
    return LabeledEdit_GetName(l.instance)
}

// CN: 设置组件名称。
// EN: Set the component name.
func (l *TLabeledEdit) SetName(value string) {
    LabeledEdit_SetName(l.instance, value)
}

// CN: 获取对象标记。
// EN: Get the control tag.
func (l *TLabeledEdit) Tag() int {
    return LabeledEdit_GetTag(l.instance)
}

// CN: 设置对象标记。
// EN: Set the control tag.
func (l *TLabeledEdit) SetTag(value int) {
    LabeledEdit_SetTag(l.instance, value)
}

// CN: 获取左边锚点。
// EN: .
func (l *TLabeledEdit) AnchorSideLeft() *TAnchorSide {
    return AsAnchorSide(LabeledEdit_GetAnchorSideLeft(l.instance))
}

// CN: 设置左边锚点。
// EN: .
func (l *TLabeledEdit) SetAnchorSideLeft(value *TAnchorSide) {
    LabeledEdit_SetAnchorSideLeft(l.instance, CheckPtr(value))
}

// CN: 获取顶边锚点。
// EN: .
func (l *TLabeledEdit) AnchorSideTop() *TAnchorSide {
    return AsAnchorSide(LabeledEdit_GetAnchorSideTop(l.instance))
}

// CN: 设置顶边锚点。
// EN: .
func (l *TLabeledEdit) SetAnchorSideTop(value *TAnchorSide) {
    LabeledEdit_SetAnchorSideTop(l.instance, CheckPtr(value))
}

// CN: 获取右边锚点。
// EN: .
func (l *TLabeledEdit) AnchorSideRight() *TAnchorSide {
    return AsAnchorSide(LabeledEdit_GetAnchorSideRight(l.instance))
}

// CN: 设置右边锚点。
// EN: .
func (l *TLabeledEdit) SetAnchorSideRight(value *TAnchorSide) {
    LabeledEdit_SetAnchorSideRight(l.instance, CheckPtr(value))
}

// CN: 获取底边锚点。
// EN: .
func (l *TLabeledEdit) AnchorSideBottom() *TAnchorSide {
    return AsAnchorSide(LabeledEdit_GetAnchorSideBottom(l.instance))
}

// CN: 设置底边锚点。
// EN: .
func (l *TLabeledEdit) SetAnchorSideBottom(value *TAnchorSide) {
    LabeledEdit_SetAnchorSideBottom(l.instance, CheckPtr(value))
}

func (l *TLabeledEdit) ChildSizing() *TControlChildSizing {
    return AsControlChildSizing(LabeledEdit_GetChildSizing(l.instance))
}

func (l *TLabeledEdit) SetChildSizing(value *TControlChildSizing) {
    LabeledEdit_SetChildSizing(l.instance, CheckPtr(value))
}

// CN: 获取边框间距。
// EN: .
func (l *TLabeledEdit) BorderSpacing() *TControlBorderSpacing {
    return AsControlBorderSpacing(LabeledEdit_GetBorderSpacing(l.instance))
}

// CN: 设置边框间距。
// EN: .
func (l *TLabeledEdit) SetBorderSpacing(value *TControlBorderSpacing) {
    LabeledEdit_SetBorderSpacing(l.instance, CheckPtr(value))
}

// CN: 获取指定索引停靠客户端。
// EN: .
func (l *TLabeledEdit) DockClients(Index int32) *TControl {
    return AsControl(LabeledEdit_GetDockClients(l.instance, Index))
}

// CN: 获取指定索引子控件。
// EN: .
func (l *TLabeledEdit) Controls(Index int32) *TControl {
    return AsControl(LabeledEdit_GetControls(l.instance, Index))
}

// CN: 获取指定索引组件。
// EN: Get the specified index component.
func (l *TLabeledEdit) Components(AIndex int32) *TComponent {
    return AsComponent(LabeledEdit_GetComponents(l.instance, AIndex))
}

// CN: 获取锚侧面。
// EN: .
func (l *TLabeledEdit) AnchorSide(AKind TAnchorKind) *TAnchorSide {
    return AsAnchorSide(LabeledEdit_GetAnchorSide(l.instance, AKind))
}

