
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TListItem struct {
    IObject
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// CN: 创建一个新的对象。
// EN: Create a new object.
func NewListItem(AOwner *TListItems) *TListItem {
    l := new(TListItem)
    l.instance = ListItem_Create(CheckPtr(AOwner))
    l.ptr = unsafe.Pointer(l.instance)
    // 不敢启用，因为不知道会发生什么...
    // runtime.SetFinalizer(l, (*TListItem).Free)
    return l
}

// CN: 动态转换一个已存在的对象实例。或者使用Obj.As().<目标对象>。
// EN: Dynamically convert an existing object instance. Or use Obj.As().<Target object>.
func AsListItem(obj interface{}) *TListItem {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TListItem{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// CN: 新建一个对象来自已经存在的对象实例指针。
// EN: Create a new object from an existing object instance pointer.
// Deprecated: use AsListItem.
func ListItemFromInst(inst uintptr) *TListItem {
    return AsListItem(inst)
}

// CN: 新建一个对象来自已经存在的对象实例。
// EN: Create a new object from an existing object instance.
// Deprecated: use AsListItem.
func ListItemFromObj(obj IObject) *TListItem {
    return AsListItem(obj)
}

// CN: 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// EN: Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsListItem.
func ListItemFromUnsafePointer(ptr unsafe.Pointer) *TListItem {
    return AsListItem(ptr)
}

// -------------------------- Deprecated end --------------------------
// CN: 释放对象。
// EN: Free object.
func (l *TListItem) Free() {
    if l.instance != 0 {
        ListItem_Free(l.instance)
        l.instance, l.ptr = 0, nullptr
    }
}

// CN: 返回对象实例指针。
// EN: Return object instance pointer.
func (l *TListItem) Instance() uintptr {
    return l.instance
}

// CN: 获取一个不安全的地址。
// EN: Get an unsafe address.
func (l *TListItem) UnsafeAddr() unsafe.Pointer {
    return l.ptr
}

// CN: 检测地址是否为空。
// EN: Check if the address is empty.
func (l *TListItem) IsValid() bool {
    return l.instance != 0
}

// CN: 检测当前对象是否继承自目标对象。
// EN: Checks whether the current object is inherited from the target object.
func (l *TListItem) Is() TIs {
    return TIs(l.instance)
}

// CN: 动态转换当前对象为目标对象。
// EN: Dynamically convert the current object to the target object.
//func (l *TListItem) As() TAs {
//    return TAs(l.instance)
//}

// CN: 获取类信息指针。
// EN: Get class information pointer.
func TListItemClass() TClass {
    return ListItem_StaticClassType()
}

// CN: 复制一个对象，如果对象实现了此方法的话。
// EN: Copy an object, if the object implements this method.
func (l *TListItem) Assign(Source IObject) {
    ListItem_Assign(l.instance, CheckPtr(Source))
}

func (l *TListItem) Delete() {
    ListItem_Delete(l.instance)
}

func (l *TListItem) DisplayRect(Code TDisplayCode) TRect {
    return ListItem_DisplayRect(l.instance, Code)
}

func (l *TListItem) EditCaption() bool {
    return ListItem_EditCaption(l.instance)
}

func (l *TListItem) MakeVisible(PartialOK bool) {
    ListItem_MakeVisible(l.instance, PartialOK)
}

// CN: 获取类名路径。
// EN: Get the class name path.
func (l *TListItem) GetNamePath() string {
    return ListItem_GetNamePath(l.instance)
}

// CN: 获取类的类型信息。
// EN: Get class type information.
func (l *TListItem) ClassType() TClass {
    return ListItem_ClassType(l.instance)
}

// CN: 获取当前对象类名称。
// EN: Get the current object class name.
func (l *TListItem) ClassName() string {
    return ListItem_ClassName(l.instance)
}

// CN: 获取当前对象实例大小。
// EN: Get the current object instance size.
func (l *TListItem) InstanceSize() int32 {
    return ListItem_InstanceSize(l.instance)
}

// CN: 判断当前类是否继承自指定类。
// EN: Determine whether the current class inherits from the specified class.
func (l *TListItem) InheritsFrom(AClass TClass) bool {
    return ListItem_InheritsFrom(l.instance, AClass)
}

// CN: 与一个对象进行比较。
// EN: Compare with an object.
func (l *TListItem) Equals(Obj IObject) bool {
    return ListItem_Equals(l.instance, CheckPtr(Obj))
}

// CN: 获取类的哈希值。
// EN: Get the hash value of the class.
func (l *TListItem) GetHashCode() int32 {
    return ListItem_GetHashCode(l.instance)
}

// CN: 文本类信息。
// EN: Text information.
func (l *TListItem) ToString() string {
    return ListItem_ToString(l.instance)
}

// CN: 获取控件标题。
// EN: Get the control title.
func (l *TListItem) Caption() string {
    return ListItem_GetCaption(l.instance)
}

// CN: 设置控件标题。
// EN: Set the control title.
func (l *TListItem) SetCaption(value string) {
    ListItem_SetCaption(l.instance, value)
}

// CN: 获取是否选中。
// EN: .
func (l *TListItem) Checked() bool {
    return ListItem_GetChecked(l.instance)
}

// CN: 设置是否选中。
// EN: .
func (l *TListItem) SetChecked(value bool) {
    ListItem_SetChecked(l.instance, value)
}

func (l *TListItem) Cut() bool {
    return ListItem_GetCut(l.instance)
}

func (l *TListItem) SetCut(value bool) {
    ListItem_SetCut(l.instance, value)
}

func (l *TListItem) Data() unsafe.Pointer {
    return ListItem_GetData(l.instance)
}

func (l *TListItem) SetData(value unsafe.Pointer) {
    ListItem_SetData(l.instance, value)
}

// CN: 获取返回是否获取焦点。
// EN: Get Return to get focus.
func (l *TListItem) Focused() bool {
    return ListItem_GetFocused(l.instance)
}

// CN: 设置返回是否获取焦点。
// EN: Set Return to get focus.
func (l *TListItem) SetFocused(value bool) {
    ListItem_SetFocused(l.instance, value)
}

// CN: 获取图像在images中的索引。
// EN: .
func (l *TListItem) ImageIndex() int32 {
    return ListItem_GetImageIndex(l.instance)
}

// CN: 设置图像在images中的索引。
// EN: .
func (l *TListItem) SetImageIndex(value int32) {
    ListItem_SetImageIndex(l.instance, value)
}

func (l *TListItem) Index() int32 {
    return ListItem_GetIndex(l.instance)
}

// CN: 获取左边位置。
// EN: Get Left position.
func (l *TListItem) Left() int32 {
    return ListItem_GetLeft(l.instance)
}

// CN: 设置左边位置。
// EN: Set Left position.
func (l *TListItem) SetLeft(value int32) {
    ListItem_SetLeft(l.instance, value)
}

func (l *TListItem) ListView() *TWinControl {
    return AsWinControl(ListItem_GetListView(l.instance))
}

// CN: 获取组件所有者。
// EN: Get component owner.
func (l *TListItem) Owner() *TListItems {
    return AsListItems(ListItem_GetOwner(l.instance))
}

func (l *TListItem) Position() TPoint {
    return ListItem_GetPosition(l.instance)
}

func (l *TListItem) SetPosition(value TPoint) {
    ListItem_SetPosition(l.instance, value)
}

func (l *TListItem) Selected() bool {
    return ListItem_GetSelected(l.instance)
}

func (l *TListItem) SetSelected(value bool) {
    ListItem_SetSelected(l.instance, value)
}

func (l *TListItem) StateIndex() int32 {
    return ListItem_GetStateIndex(l.instance)
}

func (l *TListItem) SetStateIndex(value int32) {
    ListItem_SetStateIndex(l.instance, value)
}

func (l *TListItem) SubItems() *TStrings {
    return AsStrings(ListItem_GetSubItems(l.instance))
}

func (l *TListItem) SetSubItems(value IObject) {
    ListItem_SetSubItems(l.instance, CheckPtr(value))
}

// CN: 获取顶边位置。
// EN: Get Top position.
func (l *TListItem) Top() int32 {
    return ListItem_GetTop(l.instance)
}

// CN: 设置顶边位置。
// EN: Set Top position.
func (l *TListItem) SetTop(value int32) {
    ListItem_SetTop(l.instance, value)
}

func (l *TListItem) SubItemImages(Index int32) int32 {
    return ListItem_GetSubItemImages(l.instance, Index)
}

func (l *TListItem) SetSubItemImages(Index int32, value int32) {
    ListItem_SetSubItemImages(l.instance, Index, value)
}

