
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TToggleBox struct {
    IWinControl
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// CN: 创建一个新的对象。
// EN: Create a new object.
func NewToggleBox(owner IComponent) *TToggleBox {
    t := new(TToggleBox)
    t.instance = ToggleBox_Create(CheckPtr(owner))
    t.ptr = unsafe.Pointer(t.instance)
    // 不敢启用，因为不知道会发生什么...
    // runtime.SetFinalizer(t, (*TToggleBox).Free)
    return t
}

// CN: 动态转换一个已存在的对象实例。或者使用Obj.As().<目标对象>。
// EN: Dynamically convert an existing object instance. Or use Obj.As().<Target object>.
func AsToggleBox(obj interface{}) *TToggleBox {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TToggleBox{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// CN: 新建一个对象来自已经存在的对象实例指针。
// EN: Create a new object from an existing object instance pointer.
// Deprecated: use AsToggleBox.
func ToggleBoxFromInst(inst uintptr) *TToggleBox {
    return AsToggleBox(inst)
}

// CN: 新建一个对象来自已经存在的对象实例。
// EN: Create a new object from an existing object instance.
// Deprecated: use AsToggleBox.
func ToggleBoxFromObj(obj IObject) *TToggleBox {
    return AsToggleBox(obj)
}

// CN: 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// EN: Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsToggleBox.
func ToggleBoxFromUnsafePointer(ptr unsafe.Pointer) *TToggleBox {
    return AsToggleBox(ptr)
}

// -------------------------- Deprecated end --------------------------
// CN: 释放对象。
// EN: Free object.
func (t *TToggleBox) Free() {
    if t.instance != 0 {
        ToggleBox_Free(t.instance)
        t.instance, t.ptr = 0, nullptr
    }
}

// CN: 返回对象实例指针。
// EN: Return object instance pointer.
func (t *TToggleBox) Instance() uintptr {
    return t.instance
}

// CN: 获取一个不安全的地址。
// EN: Get an unsafe address.
func (t *TToggleBox) UnsafeAddr() unsafe.Pointer {
    return t.ptr
}

// CN: 检测地址是否为空。
// EN: Check if the address is empty.
func (t *TToggleBox) IsValid() bool {
    return t.instance != 0
}

// CN: 检测当前对象是否继承自目标对象。
// EN: Checks whether the current object is inherited from the target object.
func (t *TToggleBox) Is() TIs {
    return TIs(t.instance)
}

// CN: 动态转换当前对象为目标对象。
// EN: Dynamically convert the current object to the target object.
//func (t *TToggleBox) As() TAs {
//    return TAs(t.instance)
//}

// CN: 获取类信息指针。
// EN: Get class information pointer.
func TToggleBoxClass() TClass {
    return ToggleBox_StaticClassType()
}

// CN: 是否可以获得焦点。
// EN: .
func (t *TToggleBox) CanFocus() bool {
    return ToggleBox_CanFocus(t.instance)
}

// CN: 返回是否包含指定控件。
// EN: it's contain a specified control.
func (t *TToggleBox) ContainsControl(Control IControl) bool {
    return ToggleBox_ContainsControl(t.instance, CheckPtr(Control))
}

// CN: 返回指定坐标及相关属性位置控件。
// EN: Returns the specified coordinate and the relevant attribute position control..
func (t *TToggleBox) ControlAtPos(Pos TPoint, AllowDisabled bool, AllowWinControls bool, AllLevels bool) *TControl {
    return AsControl(ToggleBox_ControlAtPos(t.instance, Pos , AllowDisabled , AllowWinControls , AllLevels))
}

// CN: 禁用控件的对齐。
// EN: Disable control alignment.
func (t *TToggleBox) DisableAlign() {
    ToggleBox_DisableAlign(t.instance)
}

// CN: 启用控件对齐。
// EN: Enabled control alignment.
func (t *TToggleBox) EnableAlign() {
    ToggleBox_EnableAlign(t.instance)
}

// CN: 查找子控件。
// EN: Find sub controls.
func (t *TToggleBox) FindChildControl(ControlName string) *TControl {
    return AsControl(ToggleBox_FindChildControl(t.instance, ControlName))
}

func (t *TToggleBox) FlipChildren(AllLevels bool) {
    ToggleBox_FlipChildren(t.instance, AllLevels)
}

// CN: 返回是否获取焦点。
// EN: Return to get focus.
func (t *TToggleBox) Focused() bool {
    return ToggleBox_Focused(t.instance)
}

// CN: 句柄是否已经分配。
// EN: Is the handle already allocated.
func (t *TToggleBox) HandleAllocated() bool {
    return ToggleBox_HandleAllocated(t.instance)
}

// CN: 插入一个控件。
// EN: Insert a control.
func (t *TToggleBox) InsertControl(AControl IControl) {
    ToggleBox_InsertControl(t.instance, CheckPtr(AControl))
}

// CN: 要求重绘。
// EN: Redraw.
func (t *TToggleBox) Invalidate() {
    ToggleBox_Invalidate(t.instance)
}

// CN: 移除一个控件。
// EN: Remove a control.
func (t *TToggleBox) RemoveControl(AControl IControl) {
    ToggleBox_RemoveControl(t.instance, CheckPtr(AControl))
}

// CN: 重新对齐。
// EN: Realign.
func (t *TToggleBox) Realign() {
    ToggleBox_Realign(t.instance)
}

// CN: 重绘。
// EN: Repaint.
func (t *TToggleBox) Repaint() {
    ToggleBox_Repaint(t.instance)
}

// CN: 按比例缩放。
// EN: Scale by.
func (t *TToggleBox) ScaleBy(M int32, D int32) {
    ToggleBox_ScaleBy(t.instance, M , D)
}

// CN: 滚动至指定位置。
// EN: Scroll by.
func (t *TToggleBox) ScrollBy(DeltaX int32, DeltaY int32) {
    ToggleBox_ScrollBy(t.instance, DeltaX , DeltaY)
}

// CN: 设置组件边界。
// EN: Set component boundaries.
func (t *TToggleBox) SetBounds(ALeft int32, ATop int32, AWidth int32, AHeight int32) {
    ToggleBox_SetBounds(t.instance, ALeft , ATop , AWidth , AHeight)
}

// CN: 设置控件焦点。
// EN: Set control focus.
func (t *TToggleBox) SetFocus() {
    ToggleBox_SetFocus(t.instance)
}

// CN: 控件更新。
// EN: Update.
func (t *TToggleBox) Update() {
    ToggleBox_Update(t.instance)
}

// CN: 将控件置于最前。
// EN: Bring the control to the front.
func (t *TToggleBox) BringToFront() {
    ToggleBox_BringToFront(t.instance)
}

// CN: 将客户端坐标转为绝对的屏幕坐标。
// EN: Convert client coordinates to absolute screen coordinates.
func (t *TToggleBox) ClientToScreen(Point TPoint) TPoint {
    return ToggleBox_ClientToScreen(t.instance, Point)
}

// CN: 将客户端坐标转为父容器坐标。
// EN: Convert client coordinates to parent container coordinates.
func (t *TToggleBox) ClientToParent(Point TPoint, AParent IWinControl) TPoint {
    return ToggleBox_ClientToParent(t.instance, Point , CheckPtr(AParent))
}

// CN: 是否在拖拽中。
// EN: Is it in the middle of dragging.
func (t *TToggleBox) Dragging() bool {
    return ToggleBox_Dragging(t.instance)
}

// CN: 是否有父容器。
// EN: Is there a parent container.
func (t *TToggleBox) HasParent() bool {
    return ToggleBox_HasParent(t.instance)
}

// CN: 隐藏控件。
// EN: Hidden control.
func (t *TToggleBox) Hide() {
    ToggleBox_Hide(t.instance)
}

// CN: 发送一个消息。
// EN: Send a message.
func (t *TToggleBox) Perform(Msg uint32, WParam uintptr, LParam int) int {
    return ToggleBox_Perform(t.instance, Msg , WParam , LParam)
}

// CN: 刷新控件。
// EN: Refresh control.
func (t *TToggleBox) Refresh() {
    ToggleBox_Refresh(t.instance)
}

// CN: 将屏幕坐标转为客户端坐标。
// EN: Convert screen coordinates to client coordinates.
func (t *TToggleBox) ScreenToClient(Point TPoint) TPoint {
    return ToggleBox_ScreenToClient(t.instance, Point)
}

// CN: 将父容器坐标转为客户端坐标。
// EN: Convert parent container coordinates to client coordinates.
func (t *TToggleBox) ParentToClient(Point TPoint, AParent IWinControl) TPoint {
    return ToggleBox_ParentToClient(t.instance, Point , CheckPtr(AParent))
}

// CN: 控件至于最后面。
// EN: The control is placed at the end.
func (t *TToggleBox) SendToBack() {
    ToggleBox_SendToBack(t.instance)
}

// CN: 显示控件。
// EN: Show control.
func (t *TToggleBox) Show() {
    ToggleBox_Show(t.instance)
}

// CN: 获取控件的字符，如果有。
// EN: Get the characters of the control, if any.
func (t *TToggleBox) GetTextBuf(Buffer *string, BufSize int32) int32 {
    return ToggleBox_GetTextBuf(t.instance, Buffer , BufSize)
}

// CN: 获取控件的字符长，如果有。
// EN: Get the character length of the control, if any.
func (t *TToggleBox) GetTextLen() int32 {
    return ToggleBox_GetTextLen(t.instance)
}

// CN: 设置控件字符，如果有。
// EN: Set control characters, if any.
func (t *TToggleBox) SetTextBuf(Buffer string) {
    ToggleBox_SetTextBuf(t.instance, Buffer)
}

// CN: 查找指定名称的组件。
// EN: Find the component with the specified name.
func (t *TToggleBox) FindComponent(AName string) *TComponent {
    return AsComponent(ToggleBox_FindComponent(t.instance, AName))
}

// CN: 获取类名路径。
// EN: Get the class name path.
func (t *TToggleBox) GetNamePath() string {
    return ToggleBox_GetNamePath(t.instance)
}

// CN: 复制一个对象，如果对象实现了此方法的话。
// EN: Copy an object, if the object implements this method.
func (t *TToggleBox) Assign(Source IObject) {
    ToggleBox_Assign(t.instance, CheckPtr(Source))
}

// CN: 获取类的类型信息。
// EN: Get class type information.
func (t *TToggleBox) ClassType() TClass {
    return ToggleBox_ClassType(t.instance)
}

// CN: 获取当前对象类名称。
// EN: Get the current object class name.
func (t *TToggleBox) ClassName() string {
    return ToggleBox_ClassName(t.instance)
}

// CN: 获取当前对象实例大小。
// EN: Get the current object instance size.
func (t *TToggleBox) InstanceSize() int32 {
    return ToggleBox_InstanceSize(t.instance)
}

// CN: 判断当前类是否继承自指定类。
// EN: Determine whether the current class inherits from the specified class.
func (t *TToggleBox) InheritsFrom(AClass TClass) bool {
    return ToggleBox_InheritsFrom(t.instance, AClass)
}

// CN: 与一个对象进行比较。
// EN: Compare with an object.
func (t *TToggleBox) Equals(Obj IObject) bool {
    return ToggleBox_Equals(t.instance, CheckPtr(Obj))
}

// CN: 获取类的哈希值。
// EN: Get the hash value of the class.
func (t *TToggleBox) GetHashCode() int32 {
    return ToggleBox_GetHashCode(t.instance)
}

// CN: 文本类信息。
// EN: Text information.
func (t *TToggleBox) ToString() string {
    return ToggleBox_ToString(t.instance)
}

func (t *TToggleBox) AnchorToNeighbour(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    ToggleBox_AnchorToNeighbour(t.instance, ASide , ASpace , CheckPtr(ASibling))
}

func (t *TToggleBox) AnchorParallel(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    ToggleBox_AnchorParallel(t.instance, ASide , ASpace , CheckPtr(ASibling))
}

// CN: 置于指定控件的横向中心。
// EN: .
func (t *TToggleBox) AnchorHorizontalCenterTo(ASibling IControl) {
    ToggleBox_AnchorHorizontalCenterTo(t.instance, CheckPtr(ASibling))
}

// CN: 置于指定控件的纵向中心。
// EN: .
func (t *TToggleBox) AnchorVerticalCenterTo(ASibling IControl) {
    ToggleBox_AnchorVerticalCenterTo(t.instance, CheckPtr(ASibling))
}

func (t *TToggleBox) AnchorAsAlign(ATheAlign TAlign, ASpace int32) {
    ToggleBox_AnchorAsAlign(t.instance, ATheAlign , ASpace)
}

func (t *TToggleBox) AnchorClient(ASpace int32) {
    ToggleBox_AnchorClient(t.instance, ASpace)
}

func (t *TToggleBox) AllowGrayed() bool {
    return ToggleBox_GetAllowGrayed(t.instance)
}

func (t *TToggleBox) SetAllowGrayed(value bool) {
    ToggleBox_SetAllowGrayed(t.instance, value)
}

// CN: 获取控件自动调整。
// EN: Get Control automatically adjusts.
func (t *TToggleBox) Align() TAlign {
    return ToggleBox_GetAlign(t.instance)
}

// CN: 设置控件自动调整。
// EN: Set Control automatically adjusts.
func (t *TToggleBox) SetAlign(value TAlign) {
    ToggleBox_SetAlign(t.instance, value)
}

// CN: 获取四个角位置的锚点。
// EN: .
func (t *TToggleBox) Anchors() TAnchors {
    return ToggleBox_GetAnchors(t.instance)
}

// CN: 设置四个角位置的锚点。
// EN: .
func (t *TToggleBox) SetAnchors(value TAnchors) {
    ToggleBox_SetAnchors(t.instance, value)
}

// CN: 获取自动调整大小。
// EN: .
func (t *TToggleBox) AutoSize() bool {
    return ToggleBox_GetAutoSize(t.instance)
}

// CN: 设置自动调整大小。
// EN: .
func (t *TToggleBox) SetAutoSize(value bool) {
    ToggleBox_SetAutoSize(t.instance, value)
}

// CN: 获取控件标题。
// EN: Get the control title.
func (t *TToggleBox) Caption() string {
    return ToggleBox_GetCaption(t.instance)
}

// CN: 设置控件标题。
// EN: Set the control title.
func (t *TToggleBox) SetCaption(value string) {
    ToggleBox_SetCaption(t.instance, value)
}

// CN: 获取是否选中。
// EN: .
func (t *TToggleBox) Checked() bool {
    return ToggleBox_GetChecked(t.instance)
}

// CN: 设置是否选中。
// EN: .
func (t *TToggleBox) SetChecked(value bool) {
    ToggleBox_SetChecked(t.instance, value)
}

// CN: 获取颜色。
// EN: Get color.
func (t *TToggleBox) Color() TColor {
    return ToggleBox_GetColor(t.instance)
}

// CN: 设置颜色。
// EN: Set color.
func (t *TToggleBox) SetColor(value TColor) {
    ToggleBox_SetColor(t.instance, value)
}

// CN: 获取约束控件大小。
// EN: .
func (t *TToggleBox) Constraints() *TSizeConstraints {
    return AsSizeConstraints(ToggleBox_GetConstraints(t.instance))
}

// CN: 设置约束控件大小。
// EN: .
func (t *TToggleBox) SetConstraints(value *TSizeConstraints) {
    ToggleBox_SetConstraints(t.instance, CheckPtr(value))
}

// CN: 获取设置控件双缓冲。
// EN: Get Set control double buffering.
func (t *TToggleBox) DoubleBuffered() bool {
    return ToggleBox_GetDoubleBuffered(t.instance)
}

// CN: 设置设置控件双缓冲。
// EN: Set Set control double buffering.
func (t *TToggleBox) SetDoubleBuffered(value bool) {
    ToggleBox_SetDoubleBuffered(t.instance, value)
}

// CN: 获取设置控件拖拽时的光标。
// EN: Get Set the cursor when the control is dragged.
func (t *TToggleBox) DragCursor() TCursor {
    return ToggleBox_GetDragCursor(t.instance)
}

// CN: 设置设置控件拖拽时的光标。
// EN: Set Set the cursor when the control is dragged.
func (t *TToggleBox) SetDragCursor(value TCursor) {
    ToggleBox_SetDragCursor(t.instance, value)
}

// CN: 获取拖拽方式。
// EN: Get Drag and drop.
func (t *TToggleBox) DragKind() TDragKind {
    return ToggleBox_GetDragKind(t.instance)
}

// CN: 设置拖拽方式。
// EN: Set Drag and drop.
func (t *TToggleBox) SetDragKind(value TDragKind) {
    ToggleBox_SetDragKind(t.instance, value)
}

// CN: 获取拖拽模式。
// EN: Get Drag mode.
func (t *TToggleBox) DragMode() TDragMode {
    return ToggleBox_GetDragMode(t.instance)
}

// CN: 设置拖拽模式。
// EN: Set Drag mode.
func (t *TToggleBox) SetDragMode(value TDragMode) {
    ToggleBox_SetDragMode(t.instance, value)
}

// CN: 获取控件启用。
// EN: Get the control enabled.
func (t *TToggleBox) Enabled() bool {
    return ToggleBox_GetEnabled(t.instance)
}

// CN: 设置控件启用。
// EN: Set the control enabled.
func (t *TToggleBox) SetEnabled(value bool) {
    ToggleBox_SetEnabled(t.instance, value)
}

// CN: 获取字体。
// EN: Get Font.
func (t *TToggleBox) Font() *TFont {
    return AsFont(ToggleBox_GetFont(t.instance))
}

// CN: 设置字体。
// EN: Set Font.
func (t *TToggleBox) SetFont(value *TFont) {
    ToggleBox_SetFont(t.instance, CheckPtr(value))
}

// CN: 获取组件鼠标悬停提示。
// EN: Get component mouse hints.
func (t *TToggleBox) Hint() string {
    return ToggleBox_GetHint(t.instance)
}

// CN: 设置组件鼠标悬停提示。
// EN: Set component mouse hints.
func (t *TToggleBox) SetHint(value string) {
    ToggleBox_SetHint(t.instance, value)
}

// CN: 设置改变事件。
// EN: Set changed event.
func (t *TToggleBox) SetOnChange(fn TNotifyEvent) {
    ToggleBox_SetOnChange(t.instance, fn)
}

// CN: 设置控件单击事件。
// EN: Set control click event.
func (t *TToggleBox) SetOnClick(fn TNotifyEvent) {
    ToggleBox_SetOnClick(t.instance, fn)
}

// CN: 设置拖拽下落事件。
// EN: Set Drag and drop event.
func (t *TToggleBox) SetOnDragDrop(fn TDragDropEvent) {
    ToggleBox_SetOnDragDrop(t.instance, fn)
}

// CN: 设置拖拽完成事件。
// EN: Set Drag and drop completion event.
func (t *TToggleBox) SetOnDragOver(fn TDragOverEvent) {
    ToggleBox_SetOnDragOver(t.instance, fn)
}

// CN: 设置拖拽结束。
// EN: Set End of drag.
func (t *TToggleBox) SetOnEndDrag(fn TEndDragEvent) {
    ToggleBox_SetOnEndDrag(t.instance, fn)
}

// CN: 设置焦点进入。
// EN: Set Focus entry.
func (t *TToggleBox) SetOnEnter(fn TNotifyEvent) {
    ToggleBox_SetOnEnter(t.instance, fn)
}

// CN: 设置焦点退出。
// EN: Set Focus exit.
func (t *TToggleBox) SetOnExit(fn TNotifyEvent) {
    ToggleBox_SetOnExit(t.instance, fn)
}

// CN: 设置鼠标按下事件。
// EN: Set Mouse down event.
func (t *TToggleBox) SetOnMouseDown(fn TMouseEvent) {
    ToggleBox_SetOnMouseDown(t.instance, fn)
}

// CN: 设置鼠标进入事件。
// EN: Set Mouse entry event.
func (t *TToggleBox) SetOnMouseEnter(fn TNotifyEvent) {
    ToggleBox_SetOnMouseEnter(t.instance, fn)
}

// CN: 设置鼠标离开事件。
// EN: Set Mouse leave event.
func (t *TToggleBox) SetOnMouseLeave(fn TNotifyEvent) {
    ToggleBox_SetOnMouseLeave(t.instance, fn)
}

// CN: 设置鼠标移动事件。
// EN: .
func (t *TToggleBox) SetOnMouseMove(fn TMouseMoveEvent) {
    ToggleBox_SetOnMouseMove(t.instance, fn)
}

// CN: 设置鼠标抬起事件。
// EN: Set Mouse lift event.
func (t *TToggleBox) SetOnMouseUp(fn TMouseEvent) {
    ToggleBox_SetOnMouseUp(t.instance, fn)
}

// CN: 设置鼠标滚轮事件。
// EN: .
func (t *TToggleBox) SetOnMouseWheel(fn TMouseWheelEvent) {
    ToggleBox_SetOnMouseWheel(t.instance, fn)
}

// CN: 设置鼠标滚轮按下事件。
// EN: .
func (t *TToggleBox) SetOnMouseWheelDown(fn TMouseWheelUpDownEvent) {
    ToggleBox_SetOnMouseWheelDown(t.instance, fn)
}

// CN: 设置鼠标滚轮抬起事件。
// EN: .
func (t *TToggleBox) SetOnMouseWheelUp(fn TMouseWheelUpDownEvent) {
    ToggleBox_SetOnMouseWheelUp(t.instance, fn)
}

// CN: 获取父容器双缓冲。
// EN: Get Parent container double buffering.
func (t *TToggleBox) ParentDoubleBuffered() bool {
    return ToggleBox_GetParentDoubleBuffered(t.instance)
}

// CN: 设置父容器双缓冲。
// EN: Set Parent container double buffering.
func (t *TToggleBox) SetParentDoubleBuffered(value bool) {
    ToggleBox_SetParentDoubleBuffered(t.instance, value)
}

// CN: 获取父容器字体。
// EN: Get Parent container font.
func (t *TToggleBox) ParentFont() bool {
    return ToggleBox_GetParentFont(t.instance)
}

// CN: 设置父容器字体。
// EN: Set Parent container font.
func (t *TToggleBox) SetParentFont(value bool) {
    ToggleBox_SetParentFont(t.instance, value)
}

// CN: 获取以父容器的ShowHint属性为准。
// EN: .
func (t *TToggleBox) ParentShowHint() bool {
    return ToggleBox_GetParentShowHint(t.instance)
}

// CN: 设置以父容器的ShowHint属性为准。
// EN: .
func (t *TToggleBox) SetParentShowHint(value bool) {
    ToggleBox_SetParentShowHint(t.instance, value)
}

// CN: 获取右键菜单。
// EN: Get Right click menu.
func (t *TToggleBox) PopupMenu() *TPopupMenu {
    return AsPopupMenu(ToggleBox_GetPopupMenu(t.instance))
}

// CN: 设置右键菜单。
// EN: Set Right click menu.
func (t *TToggleBox) SetPopupMenu(value IComponent) {
    ToggleBox_SetPopupMenu(t.instance, CheckPtr(value))
}

// CN: 获取显示鼠标悬停提示。
// EN: Get Show mouseover tips.
func (t *TToggleBox) ShowHint() bool {
    return ToggleBox_GetShowHint(t.instance)
}

// CN: 设置显示鼠标悬停提示。
// EN: Set Show mouseover tips.
func (t *TToggleBox) SetShowHint(value bool) {
    ToggleBox_SetShowHint(t.instance, value)
}

func (t *TToggleBox) State() TCheckBoxState {
    return ToggleBox_GetState(t.instance)
}

func (t *TToggleBox) SetState(value TCheckBoxState) {
    ToggleBox_SetState(t.instance, value)
}

// CN: 获取Tab切换顺序序号。
// EN: Get Tab switching sequence number.
func (t *TToggleBox) TabOrder() TTabOrder {
    return ToggleBox_GetTabOrder(t.instance)
}

// CN: 设置Tab切换顺序序号。
// EN: Set Tab switching sequence number.
func (t *TToggleBox) SetTabOrder(value TTabOrder) {
    ToggleBox_SetTabOrder(t.instance, value)
}

// CN: 获取Tab可停留。
// EN: Get Tab can stay.
func (t *TToggleBox) TabStop() bool {
    return ToggleBox_GetTabStop(t.instance)
}

// CN: 设置Tab可停留。
// EN: Set Tab can stay.
func (t *TToggleBox) SetTabStop(value bool) {
    ToggleBox_SetTabStop(t.instance, value)
}

// CN: 获取控件可视。
// EN: Get the control visible.
func (t *TToggleBox) Visible() bool {
    return ToggleBox_GetVisible(t.instance)
}

// CN: 设置控件可视。
// EN: Set the control visible.
func (t *TToggleBox) SetVisible(value bool) {
    ToggleBox_SetVisible(t.instance, value)
}

// CN: 获取依靠客户端总数。
// EN: .
func (t *TToggleBox) DockClientCount() int32 {
    return ToggleBox_GetDockClientCount(t.instance)
}

// CN: 获取停靠站点。
// EN: Get Docking site.
func (t *TToggleBox) DockSite() bool {
    return ToggleBox_GetDockSite(t.instance)
}

// CN: 设置停靠站点。
// EN: Set Docking site.
func (t *TToggleBox) SetDockSite(value bool) {
    ToggleBox_SetDockSite(t.instance, value)
}

// CN: 获取鼠标是否在客户端，仅VCL有效。
// EN: Get Whether the mouse is on the client, only VCL is valid.
func (t *TToggleBox) MouseInClient() bool {
    return ToggleBox_GetMouseInClient(t.instance)
}

// CN: 获取当前停靠的可视总数。
// EN: Get The total number of visible calls currently docked.
func (t *TToggleBox) VisibleDockClientCount() int32 {
    return ToggleBox_GetVisibleDockClientCount(t.instance)
}

// CN: 获取画刷对象。
// EN: Get Brush.
func (t *TToggleBox) Brush() *TBrush {
    return AsBrush(ToggleBox_GetBrush(t.instance))
}

// CN: 获取子控件数。
// EN: Get Number of child controls.
func (t *TToggleBox) ControlCount() int32 {
    return ToggleBox_GetControlCount(t.instance)
}

// CN: 获取控件句柄。
// EN: Get Control handle.
func (t *TToggleBox) Handle() HWND {
    return ToggleBox_GetHandle(t.instance)
}

// CN: 获取父容器句柄。
// EN: Get Parent container handle.
func (t *TToggleBox) ParentWindow() HWND {
    return ToggleBox_GetParentWindow(t.instance)
}

// CN: 设置父容器句柄。
// EN: Set Parent container handle.
func (t *TToggleBox) SetParentWindow(value HWND) {
    ToggleBox_SetParentWindow(t.instance, value)
}

func (t *TToggleBox) Showing() bool {
    return ToggleBox_GetShowing(t.instance)
}

// CN: 获取使用停靠管理。
// EN: .
func (t *TToggleBox) UseDockManager() bool {
    return ToggleBox_GetUseDockManager(t.instance)
}

// CN: 设置使用停靠管理。
// EN: .
func (t *TToggleBox) SetUseDockManager(value bool) {
    ToggleBox_SetUseDockManager(t.instance, value)
}

func (t *TToggleBox) Action() *TAction {
    return AsAction(ToggleBox_GetAction(t.instance))
}

func (t *TToggleBox) SetAction(value IComponent) {
    ToggleBox_SetAction(t.instance, CheckPtr(value))
}

func (t *TToggleBox) BiDiMode() TBiDiMode {
    return ToggleBox_GetBiDiMode(t.instance)
}

func (t *TToggleBox) SetBiDiMode(value TBiDiMode) {
    ToggleBox_SetBiDiMode(t.instance, value)
}

func (t *TToggleBox) BoundsRect() TRect {
    return ToggleBox_GetBoundsRect(t.instance)
}

func (t *TToggleBox) SetBoundsRect(value TRect) {
    ToggleBox_SetBoundsRect(t.instance, value)
}

// CN: 获取客户区高度。
// EN: Get client height.
func (t *TToggleBox) ClientHeight() int32 {
    return ToggleBox_GetClientHeight(t.instance)
}

// CN: 设置客户区高度。
// EN: Set client height.
func (t *TToggleBox) SetClientHeight(value int32) {
    ToggleBox_SetClientHeight(t.instance, value)
}

func (t *TToggleBox) ClientOrigin() TPoint {
    return ToggleBox_GetClientOrigin(t.instance)
}

// CN: 获取客户区矩形。
// EN: Get client rectangle.
func (t *TToggleBox) ClientRect() TRect {
    return ToggleBox_GetClientRect(t.instance)
}

// CN: 获取客户区宽度。
// EN: Get client width.
func (t *TToggleBox) ClientWidth() int32 {
    return ToggleBox_GetClientWidth(t.instance)
}

// CN: 设置客户区宽度。
// EN: Set client width.
func (t *TToggleBox) SetClientWidth(value int32) {
    ToggleBox_SetClientWidth(t.instance, value)
}

// CN: 获取控件状态。
// EN: Get control state.
func (t *TToggleBox) ControlState() TControlState {
    return ToggleBox_GetControlState(t.instance)
}

// CN: 设置控件状态。
// EN: Set control state.
func (t *TToggleBox) SetControlState(value TControlState) {
    ToggleBox_SetControlState(t.instance, value)
}

// CN: 获取控件样式。
// EN: Get control style.
func (t *TToggleBox) ControlStyle() TControlStyle {
    return ToggleBox_GetControlStyle(t.instance)
}

// CN: 设置控件样式。
// EN: Set control style.
func (t *TToggleBox) SetControlStyle(value TControlStyle) {
    ToggleBox_SetControlStyle(t.instance, value)
}

func (t *TToggleBox) Floating() bool {
    return ToggleBox_GetFloating(t.instance)
}

// CN: 获取控件父容器。
// EN: Get control parent container.
func (t *TToggleBox) Parent() *TWinControl {
    return AsWinControl(ToggleBox_GetParent(t.instance))
}

// CN: 设置控件父容器。
// EN: Set control parent container.
func (t *TToggleBox) SetParent(value IWinControl) {
    ToggleBox_SetParent(t.instance, CheckPtr(value))
}

// CN: 获取左边位置。
// EN: Get Left position.
func (t *TToggleBox) Left() int32 {
    return ToggleBox_GetLeft(t.instance)
}

// CN: 设置左边位置。
// EN: Set Left position.
func (t *TToggleBox) SetLeft(value int32) {
    ToggleBox_SetLeft(t.instance, value)
}

// CN: 获取顶边位置。
// EN: Get Top position.
func (t *TToggleBox) Top() int32 {
    return ToggleBox_GetTop(t.instance)
}

// CN: 设置顶边位置。
// EN: Set Top position.
func (t *TToggleBox) SetTop(value int32) {
    ToggleBox_SetTop(t.instance, value)
}

// CN: 获取宽度。
// EN: Get width.
func (t *TToggleBox) Width() int32 {
    return ToggleBox_GetWidth(t.instance)
}

// CN: 设置宽度。
// EN: Set width.
func (t *TToggleBox) SetWidth(value int32) {
    ToggleBox_SetWidth(t.instance, value)
}

// CN: 获取高度。
// EN: Get height.
func (t *TToggleBox) Height() int32 {
    return ToggleBox_GetHeight(t.instance)
}

// CN: 设置高度。
// EN: Set height.
func (t *TToggleBox) SetHeight(value int32) {
    ToggleBox_SetHeight(t.instance, value)
}

// CN: 获取控件光标。
// EN: Get control cursor.
func (t *TToggleBox) Cursor() TCursor {
    return ToggleBox_GetCursor(t.instance)
}

// CN: 设置控件光标。
// EN: Set control cursor.
func (t *TToggleBox) SetCursor(value TCursor) {
    ToggleBox_SetCursor(t.instance, value)
}

// CN: 获取组件总数。
// EN: Get the total number of components.
func (t *TToggleBox) ComponentCount() int32 {
    return ToggleBox_GetComponentCount(t.instance)
}

// CN: 获取组件索引。
// EN: Get component index.
func (t *TToggleBox) ComponentIndex() int32 {
    return ToggleBox_GetComponentIndex(t.instance)
}

// CN: 设置组件索引。
// EN: Set component index.
func (t *TToggleBox) SetComponentIndex(value int32) {
    ToggleBox_SetComponentIndex(t.instance, value)
}

// CN: 获取组件所有者。
// EN: Get component owner.
func (t *TToggleBox) Owner() *TComponent {
    return AsComponent(ToggleBox_GetOwner(t.instance))
}

// CN: 获取组件名称。
// EN: Get the component name.
func (t *TToggleBox) Name() string {
    return ToggleBox_GetName(t.instance)
}

// CN: 设置组件名称。
// EN: Set the component name.
func (t *TToggleBox) SetName(value string) {
    ToggleBox_SetName(t.instance, value)
}

// CN: 获取对象标记。
// EN: Get the control tag.
func (t *TToggleBox) Tag() int {
    return ToggleBox_GetTag(t.instance)
}

// CN: 设置对象标记。
// EN: Set the control tag.
func (t *TToggleBox) SetTag(value int) {
    ToggleBox_SetTag(t.instance, value)
}

// CN: 获取左边锚点。
// EN: .
func (t *TToggleBox) AnchorSideLeft() *TAnchorSide {
    return AsAnchorSide(ToggleBox_GetAnchorSideLeft(t.instance))
}

// CN: 设置左边锚点。
// EN: .
func (t *TToggleBox) SetAnchorSideLeft(value *TAnchorSide) {
    ToggleBox_SetAnchorSideLeft(t.instance, CheckPtr(value))
}

// CN: 获取顶边锚点。
// EN: .
func (t *TToggleBox) AnchorSideTop() *TAnchorSide {
    return AsAnchorSide(ToggleBox_GetAnchorSideTop(t.instance))
}

// CN: 设置顶边锚点。
// EN: .
func (t *TToggleBox) SetAnchorSideTop(value *TAnchorSide) {
    ToggleBox_SetAnchorSideTop(t.instance, CheckPtr(value))
}

// CN: 获取右边锚点。
// EN: .
func (t *TToggleBox) AnchorSideRight() *TAnchorSide {
    return AsAnchorSide(ToggleBox_GetAnchorSideRight(t.instance))
}

// CN: 设置右边锚点。
// EN: .
func (t *TToggleBox) SetAnchorSideRight(value *TAnchorSide) {
    ToggleBox_SetAnchorSideRight(t.instance, CheckPtr(value))
}

// CN: 获取底边锚点。
// EN: .
func (t *TToggleBox) AnchorSideBottom() *TAnchorSide {
    return AsAnchorSide(ToggleBox_GetAnchorSideBottom(t.instance))
}

// CN: 设置底边锚点。
// EN: .
func (t *TToggleBox) SetAnchorSideBottom(value *TAnchorSide) {
    ToggleBox_SetAnchorSideBottom(t.instance, CheckPtr(value))
}

func (t *TToggleBox) ChildSizing() *TControlChildSizing {
    return AsControlChildSizing(ToggleBox_GetChildSizing(t.instance))
}

func (t *TToggleBox) SetChildSizing(value *TControlChildSizing) {
    ToggleBox_SetChildSizing(t.instance, CheckPtr(value))
}

// CN: 获取边框间距。
// EN: .
func (t *TToggleBox) BorderSpacing() *TControlBorderSpacing {
    return AsControlBorderSpacing(ToggleBox_GetBorderSpacing(t.instance))
}

// CN: 设置边框间距。
// EN: .
func (t *TToggleBox) SetBorderSpacing(value *TControlBorderSpacing) {
    ToggleBox_SetBorderSpacing(t.instance, CheckPtr(value))
}

// CN: 获取指定索引停靠客户端。
// EN: .
func (t *TToggleBox) DockClients(Index int32) *TControl {
    return AsControl(ToggleBox_GetDockClients(t.instance, Index))
}

// CN: 获取指定索引子控件。
// EN: .
func (t *TToggleBox) Controls(Index int32) *TControl {
    return AsControl(ToggleBox_GetControls(t.instance, Index))
}

// CN: 获取指定索引组件。
// EN: Get the specified index component.
func (t *TToggleBox) Components(AIndex int32) *TComponent {
    return AsComponent(ToggleBox_GetComponents(t.instance, AIndex))
}

// CN: 获取锚侧面。
// EN: .
func (t *TToggleBox) AnchorSide(AKind TAnchorKind) *TAnchorSide {
    return AsAnchorSide(ToggleBox_GetAnchorSide(t.instance, AKind))
}

